'''Dungeons and Dragons Mod for Source
Mod Based of Dungeons and Dragons 4.0 System (Pen and Paper)
Preview Info: http://dnd4.com/phb
By: J3ff Hoogland
First Version found @ http://addons.eventscripts.com/addons/view/dnd (Based on 3.5)'''
import es, popuplib, random, gamethread, cPickle, os.path, math, langlib, playerlib, gc, effectlib, traceback, sys, inputlib
info = es.AddonInfo()
info.name = 'Dungeons and Dragons: Source'
info.version = '0.2.0 Python'
info.url = 'www.DnDSource.net'
info.basename = 'dnds'
info.author = 'J3ff Hoogland'
es.ServerVar('DnD',info.version,'Dungeons and Dragons By: J3ff Hoogland').makepublic()
def player_say(ev):
    '''Some cheatish chat commands for testing things.'''
    if ev['text'] == '!paragon':
        getPlayer(ev['userid'])['Character'].GiveLevel(10)
#Debug Blocks
def report(message):
    if int(es.ServerVar('dnds_Debug')):
        if int(es.ServerVar('dnds_Debug')) == 1:
            es.dbgmsg(0, '[Dungeons and Dragons] Debug - %s'%message)
        else:
            es.msg('#multi', '#green[Dungeons and Dragons] Debug - #default%s'%message)
        a = open(es.getAddonPath('dnds') + '/debug.txt','a')
        a.writelines('\n %s' % message)
        es.msg(message)
        a.close()
#Being Events
#Begin Player Events
def player_connect(ev):
    report('%s connected'%ev['name'])
def player_disconnect(ev):
    userid = int(ev['userid'])
    for d in Players[userid]['delay list']:
        gamethread.cancelDelayed(d)
    delPlayer(userid)
def player_spawn(ev):
    report('%s spawned'%ev['es_username'])
    userid = int(ev['userid'])
    getPlayer(userid)['Player'].CheckCharacter()
    if 'Ranger' in getPlayer(userid)['Character'].key['classes'] and not getPlayer(userid)['Character'].key['weapon type']:
        popuplib.send('ranger type', userid)
    elif len(getPlayer(userid)['Character'].key['stat increase']):
        getPlayer(userid)['Menu'].IncreaseStat(userid)
    elif 'unspent' in getPlayer(userid)['Character'].key['feats']:
        popuplib.send('feat info', userid)
    '''elif getPlayer(userid)['Character'].key['paragon path'] == 'pending':
        getPlayer(userid)['Menu'].ParagonMenu()
    elif getPlayer(userid)['Character'].key['paragon path'] == 'multi class' and len(getPlayer(userid)['Character'].key['classes']) == 1:
        getPlayer(userid)['Menu'].MultiMenu()'''
def player_jump(ev):
    userid = int(ev['userid'])
    jump_multiplier = getPlayer(userid)['Player'].key['long jump']
    temp_multiplier = jump_multiplier - 1
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
def player_death(ev):
    global Players
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if ev['es_attackerteam'] != ev['es_userteam'] and attacker:
        getPlayer(attacker)['Character'].GiveXp(int(es.ServerVar('dnds_KillXp')), text('player_death 1',{'es_username':ev['es_username']},getPlayer(attacker)['playerlib'].get('lang')))
    for d in Players[userid]['delay list']:
        gamethread.cancelDelayed(d)
    Players[userid]['delay list'] = []
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.event('initialize', 'player_damage')
        es.event('setint','player_damage','userid',userid)
        es.event('setint','player_damage','dmg_health',getPlayer(userid)['Player'].key['health']-int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('setint','player_damage','attacker',attacker)
        if attacker:
            es.event('setstring','player_damage','weapon',getPlayer(attacker)['playerlib'].get('weapon'))
        else:
            es.event('setstring','player_damage','weapon','world')
        es.event('setint','player_damage','health',int(es.getplayerprop(userid,'CBasePlayer.m_iHealth')))
        es.event('fire','player_damage')
#End Player Events
#Begin global events
def es_map_start(ev):
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
def round_end(ev):
    winner = int(ev['winner'])
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    Players['delay list'] = []
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
            Players[id]['delay list'] = []
def est_map_end(ev):
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    Players['delay list'] = []
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
            Players[id]['delay list'] = []
#End global events
#End Events
#Begin Looping Methods
#Our looping method that handel things such as saving and messaging that the mod is running
def LoopBlock():
    for userid in es.getUseridList():
        es.tell(userid, '#multi', text('LoopBlock 1',{},getPlayer(userid)['playerlib'].get('lang')))
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    gamethread.delayedname(30, 'dnds loop', LoopBlock)
#Looping block that keep's all user's gravity at the correct amount
def Check():
    for userid in es.getUseridList():
        getPlayer(userid)['Player'].CheckCharacter()
        es.server.queuecmd('es_xfire %s %s %s %s'%(userid, '!self', 'addoutput', '"gravity %s"'%getPlayer(userid)['Player'].key['gravity']))
    gamethread.delayedname(0.5, 'dnds check', Check)
#Loops everytime the server tics (used to player_damage for none CSS/dods games)
def Ticker():
    for id in es.getUseridList():
        getPlayer(id)['Player'].key['health'] = int(es.getplayerprop(id,'CBasePlayer.m_iHealth'))
#End looping methods
#Begin Load Method (And commands)
Players = {'delay list':[]}
Race_List = ['Dragonborn','Dwarf','Eladrin','Elf','Half Elf','Halfling','Human','Tiefling']
Classes = {'Cleric':{'paragon paths':['Angelic Avenger',
                                    'Radiant Servant',
                                    'Warpriest']},
    'Fighter':{     'paragon paths':['Iron Master',
                                    'Kensi',
                                    'Pit Fighter']},
    'Paladin':{     'paragon paths':['Astral Weapon',
                                    'Champion of Order',
                                    'Hospitaler']},
    'Ranger':{      'paragon paths':['Battlefield Archer',
                                    'Pathfinder',
                                    'Stormwarden']},
    'Rogue':{       'paragon paths':['Daggermaster',
                                    'Master Infiltrator',
                                    'Shadow Assassin']},
    'Warlock':{     'paragon paths':['Doomsayer',
                                    'Feytouched',
                                    'Life-Stealer']},
    'Warlord':{     'paragon paths':['Battle Captain',
                                    'Knight Veteran',
                                    'Sword Marshal']},
    'Wizard':{      'paragon paths':['Battle Mage',
                                    'Blood Mage',
                                    'Spellstorm Mage']}}
Class_Infos = {
                'cstrike':{'Cleric':{'base':{'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 90'},
                                                                'line3':{'en':' Weapons: All Pistols, plus the M3, Galil, and Famas'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Healing Word - word - Triggers a healing surge for your target. (Level 1)'},
                                                        'line2':{'en':' Passive: Priest\'s Shield - Take reduced damage from attacks. (Level 2)'},
                                                        'line3':{'en':' Passive: Sacred Flame - Your attacks may cause extra damage and burn your victim. (Level 3)'},
                                                        'line4':{'en':' Command: Divine Glow - glow - Damage nearby oppnents and buff nearby allies. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Wrathful Thunder - Have a chance to stun those your attacks hit. (Level 6)'},
                                                        'line2':{'en':' Passive: Beacon of Hope - When attacking you may release healing energy for nearby allies. (Level 7)'},
                                                        'line3':{'en':' Command: Guardian of Faith - guard - For a short time deal damage to all that come near you. (Level 9)'},
                                                        'line4':{'en':' Command: Cure Light Wounds - clw - Your target heals without spending a healing surge. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Fighter':{'base':{                         'line1':{'en':' Base Health - 150'},
                                                                'line2':{'en':' Base Armor - 100'},
                                                                'line3':{'en':' Weapons: All Pistols, Rifles, SMGs, and ShotGuns, plus the Scout and M249'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Passive: Cleave - Your attacks deal damage to a second enemy near your target. (Level 1)'},
                                                        'line2':{'en':' Passive: Tide of Iron - Your attacks may push your target backwards. (Level 2)'},
                                                        'line3':{'en':' Passive: Steel Serpent Strike - Have a chance to slow your victim. (Level 3)'},
                                                        'line4':{'en':' Passive: Comeback Strike - Have a chance to auto trigger a healing surge when bloodied on attacking. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Unstoppable - unstop - Gain a temporary hit point boost. (Level 6)'},
                                                        'line2':{'en':' Passive: Crushing Blow - Your attacks deal bonus damage based on your constitution score. (Level 7)'},
                                                        'line3':{'en':' Passive: Unbreakable - You take reduced damage from attacks. (Level 9)'},
                                                        'line4':{'en':' Passive: Boundless Endurance - Slowly regain health when you are bloodied. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Paladin':{'base':{     'line1':{'en':' Base Health - 150'},
                                                                'line2':{'en':' Base Armor - 125 + Helmet'},
                                                                'line3':{'en':' Weapons: All Pistols, Rifles, SMGs, and ShotGuns, plus the Scout and M249'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Passive: Divine Strength - Your attacks deal increase damage. (Level 1)'},
                                                        'line2':{'en':' Command: Lay on Hands - hands - Spend a healing surge to heal nearby target ally. (Level 2)'},
                                                        'line3':{'en':' Passive: Radiant Smite - Your wisdom increases the amount of damage your attacks do. (Level 3)'},
                                                        'line4':{'en':' Passive: Radiant Dellrium - Your attacks may daze your victim. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Sacred Circle - You and all nearby allies take reduced damage from attacks. (Level 6)'},
                                                        'line2':{'en':' Passive: Invigorating Smite - You and all nearby bloodied allies may heal when you land an attack. (Level 7)'},
                                                        'line3':{'en':' Passive: Staggering Smite - Your attacks may push back the person they hit. (Level 9)'},
                                                        'line4':{'en':' Command: Benign Transposition - transpos - Switch places with target bloodied ally. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Ranger':{'base':{      'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 90'},
                                                                'line3':{'en':' Weapons: All Pistols, SGMs, and Rifles, plus the Scout'},
                                                                'line4':{'en':'-> 1. Two Weapon Fighting Skills'},
                                                                'line5':{'en':'-> 2. Archer Skills'},
                                                                'line6':{'en':'-> 4. Paragon Paths'},
                                                                'line7':{'en':'-> 8. Select This Class'}},
                        'archer powers1':{ 'line1':{'en':' Passive: Nimble Strike - Your dexterity grants you bonus damage with your scout. (Level 1)'},
                                                        'line2':{'en':' Passive: Careful Attack - Your attacks have a chance to do increased damage. (Level 2)'},
                                                        'line3':{'en':' Passive: Two Fanged Strike - Your wisdom grants you bonus damage with your scout. (Level 3)'},
                                                        'line4':{'en':' Passive: Hunter\'s Bear Trap - Your attacks may cripple your victim for a short time. (Level 5)'}},
                        'archer powers2':{ 'line1':{'en':' Passive: Split the Tree - Your scout also damages a second target near the first. (Level 6)'},
                                                        'line2':{'en':' Passive: Thundertusk Boar Strike - Your scout may push the target backwards. (Level 7)'},
                                                        'line3':{'en':' Passive: Excruciating Shot - Your scout may weaken the person it hits. (Level 9)'},
                                                        'line4':{'en':' Passive: Weave Through the Fray - You gain a speed boost based on your wisdom score. (Level 10)'}},
                        'archer powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}},
                        'two weapon powers1':{ 'line1':{'en':' Passive: Hit and Run - You gain a short speed increase when you land a hit with a pistol. (Level 1)'},
                                                        'line2':{'en':' Passive: Careful Attack - Your attacks have a chance to do increased damage. (Level 2)'},
                                                        'line3':{'en':' Command: Dire Wolverine Strike - wolv - If you are weilding a pistol deal damage to all those around you. (Level 3)'},
                                                        'line4':{'en':' Passive: Hunter\'s Bear Trap - Your attacks may cripple your victim for a short time. (Level 5)'}},
                        'two weapon powers2':{ 'line1':{'en':' Passive: Unbalancing Parry - Throw and enemy off when you dodge their attack. (Level 6)'},
                                                        'line2':{'en':' Passive: Thundertusk Boar Strike - Your pistol may push the target backwards. (Level 7)'},
                                                        'line3':{'en':' Passive: Sweeping Whirl Wind - Your pistol may damage and push back all those around you. (Level 9)'},
                                                        'line4':{'en':' Passive: Weave Through the Fray - You gain a speed boost based on your wisdom score. (Level 10)'}},
                        'two weapon powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Rogue':{'base':{       'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 90'},
                                                                'line3':{'en':' Weapons: All Pistols, and SMGs plus the Scout'},
                                                                'line4':{'en':' Passive: Stealth - When walking or crouching you become harder to see.'},
                                                                'line5':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line6':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line7':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line8':{'en':'-> 4. Paragon Paths'},
                                                                'line9':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Triggered: Sneak Attack - If you attack someone while stealthed you attack deals bonus damage. (Level 1)'},
                                                        'line2':{'en':' Passive: Deft Strike - You add bonus damage based on your dexterity score instead of strength. (Level 2)'},
                                                        'line3':{'en':' Passive: Riposte Strike - When you are struck have a chance to deal damage back to your attacker. (Level 3)'},
                                                        'line4':{'en':' Passive: Torturous Strike - Your attacks may deal double damage. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Blinding Barrage - Your attacks may blind your victim for a short time. (Level 6)'},
                                                        'line2':{'en':' Passive: Great Leap - You are able to jump farther. (Level 7)'},
                                                        'line3':{'en':' Passive: Easy Target - Your attacks may slow the target. (Level 9)'},
                                                        'line4':{'en':' Passive: Deep Cut - Your attacks may cause on going damage to your victim. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Warlock':{'base':{     'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 60'},
                                                                'line3':{'en':' Weapons: All Pistols plus the UMP45'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Eldritch Blast - blast - Strike the person under your cursor with an energy attack. (Level 1)'},
                                                        'line2':{'en':' Passive: Hellish Rebuke - Have a chance to smite with fire anyone that hits you. (Level 2)'},
                                                        'line3':{'en':' Passive: Vampiric Embrace - Your attacks restore your health. (Level 3)'},
                                                        'line4':{'en':' Passive: Dread Star - Have a chance to freeze the person your attack. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Flames of Phlegethos - Your attacks may set fire to the person you hit. (Level 6)'},
                                                        'line2':{'en':' Command: Fiendish Resillience - resil - Gain a temporary hit point boost. (Level 7)'},
                                                        'line3':{'en':' Command: Fiery Bolt - bolt - Deal damage to your target and those around him. (Level 9)'},
                                                        'line4':{'en':' Command: Otherwind Stride - stride - Freeze your target and then jump close to them. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Warlord':{'base':{     'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 90'},
                                                                'line3':{'en':' Weapons: All Pistols, SMGs, and ShotGuns, plus Galil and Famas'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Inspiring Word - word - Triggers a healing surge for your target. (Level 1)'},
                                                        'line2':{'en':' Passive: Viper\'s Strike - Those that retreat from your attacks take extra damage. (Level 2)'},
                                                        'line3':{'en':' Passive: Leaf on the Wind - Your attacks may slide around you and your victim disorienting them. (Level 3)'},
                                                        'line4':{'en':' Passive: Bastion of Defense - Allies around you take reduced damage from attacks. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Crescendo of Violence - crescendo - Your target gains a short hit point boost based on your charisma score. (Level 6)'},
                                                        'line2':{'en':' Passive: Hold the Line - You and nearby allies cannot be pushed. (Level 7)'},
                                                        'line3':{'en':' Passive: Warlord\'s Strike - Striking an enemy causes them to take increased damage from your allies. (Level 9)'},
                                                        'line4':{'en':' Command: Stand the Fallen - stand - All nearby bloodied allies trigger a healing surge. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Wizard':{'base':{      'line1':{'en':' Base Health - 100'},
                                                                'line2':{'en':' Base Armor - 25'},
                                                                'line3':{'en':' Weapons: All Pistols'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Magic Missile - missile - Deal force damage to the person under your cursor. (Level 1)'},
                                                        'line2':{'en':' Command: Ray of Frost - frost - Deal cold damage and slow the person under your cursor. (Level 2)'},
                                                        'line3':{'en':' Command: Scorching Burst - burst - Deal fire damage to and possibly burn your target and those around them. (Level 3)'},
                                                        'line4':{'en':' Command: Thunderwave - wave - Deal damage and push back those around you. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Ray of Enfeeblement - enfeeble - Damage and weaken your target. (Level 6)'},
                                                        'line2':{'en':' Command: Acid Arrow - acid - Deals damage over time to your target and those around them. (Level 7)'},
                                                        'line3':{'en':' Command: Ice Rays - ice - Your target and another enemy near them are damaged and frozen. (Level 9)'},
                                                        'line4':{'en':' Command: Fire Ball - fireball - Damage and burn your target and all those around them. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}}},
                'pvkii':{'Cleric':{'base':{'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 120'},
                                                                'line3':{'en':' Weapons - Two Handed Axe and Sword & Shield'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Healing Word - word - Triggers a healing surge for your target. (Level 1)'},
                                                        'line2':{'en':' Passive: Priest\'s Shield - Take reduced damage from attacks. (Level 2)'},
                                                        'line3':{'en':' Passive: Sacred Flame - Your attacks may cause extra damage and burn your victim. (Level 3)'},
                                                        'line4':{'en':' Command: Divine Glow - glow - Damage nearby oppnents and buff nearby allies. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Wrathful Thunder - Have a chance to stun those your attacks hit. (Level 6)'},
                                                        'line2':{'en':' Passive: Beacon of Hope - When attacking you may release healing energy for nearby allies. (Level 7)'},
                                                        'line3':{'en':' Command: Guardian of Faith - guard - For a short time deal damage to all that come near you. (Level 9)'},
                                                        'line4':{'en':' Command: Cure Light Wounds - clw - Your target heals without spending a healing surge. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Fighter':{'base':{                         'line1':{'en':' Base Health - 150'},
                                                                'line2':{'en':' Base Armor - 150'},
                                                                'line3':{'en':' Weapons - Great Axe, Crossbow, and Throwing Axes'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Passive: Cleave - Your meele attacks cleave into a second target. (Level 1)'},
                                                        'line2':{'en':' Passive: Tide of Iron - Your meele attacks may push your target backwards. (Level 2)'},
                                                        'line3':{'en':' Passive: Steel Serpent Strike - Have a chance to slow your victim. (Level 3)'},
                                                        'line4':{'en':' Passive: Comeback Strike - Have a chance to auto trigger a healing surge when bloodied on attacking. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Unstoppable - unstop - Gain a temporary hit point boost. (Level 6)'},
                                                        'line2':{'en':' Passive: Crushing Blow - Your meele attacks deal bonus damage based on your constitution score. (Level 7)'},
                                                        'line3':{'en':' Passive: Unbreakable - You take reduced damage from attacks. (Level 9)'},
                                                        'line4':{'en':' Passive: Boundless Endurance - Slowly regain health when you are bloodied. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Paladin':{'base':{     'line1':{'en':' Base Health - 150'},
                                                                'line2':{'en':' Base Armor - 150'},
                                                                'line3':{'en':' Weapons - Great Sword and Sword & Shield'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Passive: Divine Strength - Your attacks deal increase damage. (Level 1)'},
                                                        'line2':{'en':' Command: Lay on Hands - hands - Spend a healing surge to heal nearby target ally. (Level 2)'},
                                                        'line3':{'en':' Passive: Radiant Smite - Your wisdom increases the amount of damage your attacks do. (Level 3)'},
                                                        'line4':{'en':' Passive: Radiant Dellrium - Your attacks may daze your victim. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Sacred Circle - You and all nearby allies take reduced damage from attacks. (Level 6)'},
                                                        'line2':{'en':' Passive: Invigorating Smite - You and all nearby bloodied allies may heal when you land an attack. (Level 7)'},
                                                        'line3':{'en':' Passive: Staggering Smite - Your attacks may push back the person they hit. (Level 9)'},
                                                        'line4':{'en':' Command: Benign Transposition - transpos - Switch places with target bloodied ally. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Ranger':{'base':{      'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 100'},
                                                                'line3':{'en':' Weapons - Scimitar and Double Weapons or Longbow'},
                                                                'line4':{'en':'-> 1. Two Weapon Fighting Skills'},
                                                                'line5':{'en':'-> 2. Archer Skills'},
                                                                'line6':{'en':'-> 4. Paragon Paths'},
                                                                'line7':{'en':'-> 8. Select This Class'}},
                        'archer powers1':{ 'line1':{'en':' Passive: Nimble Strike - Your dexterity grants you bonus damage with your bow. (Level 1)'},
                                                        'line2':{'en':' Passive: Careful Attack - Your attacks have a chance to do increased damage. (Level 2)'},
                                                        'line3':{'en':' Passive: Passive: Two Fanged Strike - Your wisdom grants you bonus damage with your bow. (Level 3)'},
                                                        'line4':{'en':' Passive: Hunter\'s Bear Trap - Your attacks may cripple your victim for a short time. (Level 5)'}},
                        'archer powers2':{ 'line1':{'en':' Passive: Split the Tree - Your arrows also damage a second target near the first. (Level 6)'},
                                                        'line2':{'en':' Passive: Thundertusk Boar Strike - Your arrows may push the target backwards. (Level 7)'},
                                                        'line3':{'en':' Passive: Excruciating Shot - Your arrows may weaken the person they hit. (Level 9)'},
                                                        'line4':{'en':' Passive: Weave Through the Fray - You gain a speed boost based on your wisdom score. (Level 10)'}},
                        'archer powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}},
                        'two weapon powers1':{ 'line1':{'en':' Passive: Hit and Run - You gain a short speed increase when you land a hit in meele combat. (Level 1)'},
                                                        'line2':{'en':' Passive: Careful Attack - Your attacks have a chance to do increased damage. (Level 2)'},
                                                        'line3':{'en':' Command: Dire Wolverine Strike - wolv - If you are weilding your double weapons deal damage to all those around you. (Level 3)'},
                                                        'line4':{'en':' Passive: Hunter\'s Bear Trap - Your attacks may cripple your victim for a short time. (Level 5)'}},
                        'two weapon powers2':{ 'line1':{'en':' Passive: Unbalancing Parry - Throw and enemy off when you block their attack. (Level 6)'},
                                                        'line2':{'en':' Passive: Thundertusk Boar Strike - Your dual weapons may push the target backwards. (Level 7)'},
                                                        'line3':{'en':' Passive: Sweeping Whirl Wind - Your dual weapon attacks maybe damage and push back all those around you. (Level 9)'},
                                                        'line4':{'en':' Passive: Weave Through the Fray - You gain a speed boost based on your wisdom score. (Level 10)'}},
                        'two weapon powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Rogue':{'base':{       'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 80'},
                                                                'line3':{'en':' Weapons - Rapier and Flint Lock'},
                                                                'line4':{'en':' Passive: Stealth - When walking or crouching you become harder to see.'},
                                                                'line5':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line6':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line7':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line8':{'en':'-> 4. Paragon Paths'},
                                                                'line9':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Triggered: Sneak Attack - If you attack someone while stealthed you attack deals bonus damage. (Level 1)'},
                                                        'line2':{'en':' Passive: Deft Strike - You add bonus damage based on your dexterity score instead of strength. (Level 2)'},
                                                        'line3':{'en':' Triggered: Riposte Strike - If you are struck while blocking you deal damage back to the attacker. (Level 3)'},
                                                        'line4':{'en':' Passive: Torturous Strike - Have a chance to deal double damage with your meele attacks. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Blinding Barrage - Your flint lock may blind your victim for a short time. (Level 6)'},
                                                        'line2':{'en':' Passive: Great Leap - You are able to jump farther. (Level 7)'},
                                                        'line3':{'en':' Passive: Easy Target - Your meele attacks may slow the target. (Level 9)'},
                                                        'line4':{'en':' Passive: Deep Cut - Your attacks may cause on going damage to your victim. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Warlock':{'base':{     'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 80'},
                                                                'line3':{'en':' Weapons - Short Sword and Crossbow'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Eldritch Blast - blast - Strike the person under your cursor with an energy attack. (Level 1)'},
                                                        'line2':{'en':' Passive: Hellish Rebuke - Have a chance to smite with fire anyone that hits you. (Level 2)'},
                                                        'line3':{'en':' Passive: Vampiric Embrace - Your meele attacks restore your health. (Level 3)'},
                                                        'line4':{'en':' Passive: Dread Star - Have a chance to freeze the person your attack. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Passive: Flames of Phlegethos - Your attacks may set fire to the person you hit. (Level 6)'},
                                                        'line2':{'en':' Command: Fiendish Resillience - resil - Gain a temporary hit point boost. (Level 7)'},
                                                        'line3':{'en':' Command: Fiery Bolt - bolt - Deal damage to your target and those around him. (Level 9)'},
                                                        'line4':{'en':' Command: Otherwind Stride - stride - Freeze your target and then jump close to them. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Warlord':{'base':{     'line1':{'en':' Base Health - 120'},
                                                                'line2':{'en':' Base Armor - 90'},
                                                                'line3':{'en':' Weapons - Great Sword, Sword and Shield, and Longbow'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Inspiring Word - word - Triggers a healing surge for your target. (Level 1)'},
                                                        'line2':{'en':' Passive: Viper\'s Strike - Those that retreat from your meeele attacks take extra damage. (Level 2)'},
                                                        'line3':{'en':' Passive: Leaf on the Wind - Your meele attacks may slide around you and your victim disorienting them. (Level 3)'},
                                                        'line4':{'en':' Passive: Bastion of Defense - Allies around you take reduced damage from attacks. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Crescendo of Violence - crescendo - Your target gains a short hit point boost based on your charisma score. (Level 6)'},
                                                        'line2':{'en':' Passive: Hold the Line - You and nearby allies cannot be pushed. (Level 7)'},
                                                        'line3':{'en':' Passive: Warlord\'s Strike - Striking an enemy causes them to take increased damage from your allies. (Level 9)'},
                                                        'line4':{'en':' Command: Stand the Fallen - stand - All nearby bloodied allies trigger a healing surge. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}},
                    'Wizard':{'base':{      'line1':{'en':' Base Health - 100'},
                                                                'line2':{'en':' Base Armor - 25'},
                                                                'line3':{'en':' Weapons: Short Sword'},
                                                                'line4':{'en':'-> 1. Class Powers (Levels 1-5)'},
                                                                'line5':{'en':'-> 2. Class Powers (Levels 6-10)'},
                                                                'line6':{'en':'-> 3. Class Powers (Levels 11-20)'},
                                                                'line7':{'en':'-> 4. Paragon Paths'},
                                                                'line8':{'en':'-> 8. Select This Class'}},
                        'powers1':{ 'line1':{'en':' Command: Magic Missile - missile - Deal force damage to the person under your cursor. (Level 1)'},
                                                        'line2':{'en':' Command: Ray of Frost - frost - Deal cold damage and slow the person under your cursor. (Level 2)'},
                                                        'line3':{'en':' Command: Scorching Burst - burst - Deal fire damage to and possibly burn your target and those around them. (Level 3)'},
                                                        'line4':{'en':' Command: Thunderwave - wave - Deal damage and push back those around you. (Level 5)'}},
                        'powers2':{ 'line1':{'en':' Command: Ray of Enfeeblement - enfeeble - Damage and weaken your target. (Level 6)'},
                                                        'line2':{'en':' Command: Acid Arrow - acid - Deals damage over time to your target and those around them. (Level 7)'},
                                                        'line3':{'en':' Command: Ice Rays - ice - Your target and another enemy near them are damaged and frozen. (Level 9)'},
                                                        'line4':{'en':' Command: Fire Ball - fireball - Damage and burn your target and all those around them. (Level 10)'}},
                        'powers3':{ 'line1':{'en':' '},
                                                        'line2':{'en':' '},
                                                        'line3':{'en':' '},
                                                        'line4':{'en':' '}}}}}
Paragon_Infos = {
                'cstrike':{ 'Angelic Avenger':'Cleric',
                            'Radiant Servant':'Cleric',
                            'Warpriest':'Cleric',
                            'Iron Master':'Fighter',
                            'Kensi':'Fighter',
                            'Pit Fighter':'Fighter',
                            'Astral Weapon':'Paladin',
                            'Champion of Order':'Paladin',
                            'Hospitaler':'Paladin',
                            'Battlefield Archer':'Ranger',
                            'Stormwarden':'Ranger',
                            'Pathfinder':'Ranger',
                            'Daggermaster':'Rogue',
                            'Master Infiltrator':'Rogue',
                            'Shadow Assassin':'Rogue',
                            'Doomsayer':'Warlock',
                            'Feytouched':'Warlock',
                            'Life-Stealer':'Warlock',
                            'Battle Captain':'Warlord',
                            'Knight Veteran':'Warlord',
                            'Sword Marshal':'Warlord',
                            'Battle Mage':'Wizard',
                            'Blood Mage':'Wizard',
                            'Spellstorm Mage':'Wizard',
                            'Cleric':{'Angelic Avenger':{'line1':{'en':' Passive - Astral Vibrance - Deal damage to all nearby bloodied enemies every few moments. (Level 11)'},
                                                        'line2':{'en':' Passive - Angelic Presence - Take reduced damage from attacks while you are not bloodied. (Level 12)'},
                                                        'line3':{'en':' Passive - Blood and Radiance - When a person bloodies you they are momentarly struck blind. (Level 16)'},
                                                        'line4':{'en':' Passive - Angle Ascendant - When you become bloodied temporarly become immue to attacks. (Level 20)'}},
                                    'Radiant Servant':{ 'line1':{'en':' Passive - Illuminating Attacks - Your attacks have a chance to deal double damage. (Level 11)'},
                                                        'line2':{'en':' Command - Solar Wrath - wrath - Damage all nearby enemies. (Level 12)'},
                                                        'line3':{'en':' Command - Healing Sun - +heal - Press and hold to heal yourself and all nearby allies - ends if you are bloodied. (Level 16)'},
                                                        'line4':{'en':' Command - Radiant Brilliance - brilliance - Damage your target, there is then a few moments of quiet before they explode. (Level 20)'}},
                                    'Warpriest':{       'line1':{'en':' Passive - Warpriest\'s Training - While your armor is above 70 you take reduced damage from all attacks. (Level 11)'},
                                                        'line2':{'en':' Command - Battle Cry - cry - You and all nearby bloodied allies spend a healing surge. (Level 12)'},
                                                        'line3':{'en':' Passive - Battle Favor - When you score a critical hit your heal as though you had spent a healing surge. (Level 16)'},
                                                        'line4':{'en':' Command - Battle Pyres - pyres - All nearby enemies take on going damage over the next 8 seconds. (Level 20)'}}},
                            'Fighter':{     'Iron Master':{ 'line1':{'en':' Triggered - Enduring Warrior - You regain some health when you kill an enemy. (Level 11)'},
                                                            'line2':{'en':' Passive - Iron Blow - Your attacks may blur the vision of the person you hit. (Level 12)'},
                                                            'line3':{'en':' Passive - Fantasic Flourish - You blind an enemy next to the one your attack hits. (Level 16)'},
                                                            'line4':{'en':' Passive - Crescendo Sword - Your attacks hit all those around your target as well. (Level 20)'}},
                                            'Kensi':{       'line1':{'en':' Passive - Kensei Focus - Gain bonus damage with the selected weapon group of your choice. (Level 11)'},
                                                            'line2':{'en':' Passive - Ultimate Parry - Take reduced damage from all attacks. (Level 12)'},
                                                            'line3':{'en':' Passive - Kensei Mastery - Your selected weapon group is now deadly. (Level 16)'},
                                                            'line4':{'en':' Passive - Weaponsoul Dance - Your attacks may jump and hit a second and third target. (Level 20)'}},
                                            'Pit Fighter':{ 'line1':{'en':' Passive - Armor Optimization - You take reduced damage from attacks. (Level 11)'},
                                                            'line2':{'en':' Passive - Deadly Payback - You deal extra damage to the person who last damaged you. (Level 12)'},
                                                            'line3':{'en':' Passive - Dirty Fighting - Your attacks deal bonus damage based on your wisdom score. (Level 16)'},
                                                            'line4':{'en':' Passive - Lion of Battle - Your attacks deal extra damage to bloodied enemies. (Level 20)'}}},
                            'Paladin':{     'Astral Weapon':{'line1':{'en':' Command - Astral Rejuvenation - rejuv - Heal as though you have spent a healing surge. (Level 11)'},
                                                             'line2':{'en':' Passive - Path of Light - Any enemies that come near you are struck blind. (Level 12)'},
                                                             'line3':{'en':' Passive - Astral Judgement - You destroy the armor of the person you hit. (Level 16)'},
                                                             'line4':{'en':' Command - Astral Whirlwind - whirl - Throw backwards all nearby enemies. (Level 20)'}},
                                            'Champion of Order':{'line1':{'en':' Passive - Divine Challenge - The last person you hit is marked. (Level 11)'},
                                                                 'line2':{'en':' Passive - Certain Justice - Hitting your marked target causes them to become weakened. (Level 12)'},
                                                                 'line3':{'en':' Command - None Shall Pass - none - Stun all nearby enemies. (Level 16)'},
                                                                 'line4':{'en':' Passive - Rule of Order - Striking a weakened person causes them to be stricken blind. (Level 20)'}},
                                            'Hospitaler':{   'line1':{'en':' Passive - Hospitaler\'s Blessing - Nearby allies regain health every few moments. (Level 11)'},
                                                             'line2':{'en':' Passive - Healing Font - Whenever you hit an enemy you heal a nearby ally. (Level 12)'},
                                                             'line3':{'en':' Passive - Hospitaler\'s Care - Your lay of hands heals extra based on Charisma score. (Level 16)'},
                                                             'line4':{'en':' Passive - Life Giving Smite - When you land a hit target nearby bloodied ally might spend a healing surge. (Level 20)'}}},
                            'Ranger':{      'Battlefield Archer':{  'line1':{'en':' Passive - Combined Fire - Hitting a target quickly deals extra damage. (Level 11)'},
                                                                    'line2':{'en':' Triggered - Archer\'s Glory - Killing an enemy renews your health. (Level 12)'},
                                                                    'line3':{'en':' Passive - Battlefield Experience - Have an increased chance to avoid damage from an attack. (Level 16)'},
                                                                    'line4':{'en':' Passive - Quarry\'s Bane - Your scout attacks split and hit multipul targets. (Level 20)'}},
                                            'Stormwarden':{ 'line1':{'en':' Passive - Clearing the Ground - Your attack may push back your target and those around him. (Level 11)'},
                                                            'line2':{'en':' Passive - Throw Caution to the Wind - You take and deal increased damage. (Level 12)'},
                                                            'line3':{'en':' Passive - TwinBlade Storm - Deal damage every few moments to all nearby enemies based on your Dexterity. (Level 16)'},
                                                            'line4':{'en':' Passive - Cold Steel Hurricane - Landing a hit may renew your healing surge. (Level 20)'}},
                                            'Pathfinder':{  'line1':{'en':' Passive - Battlehoned - You gain two extra healing surges per round. (Level 11)'},
                                                            'line2':{'en':' Passive - Wrong Step - Your attack may immobilize the person they hit. (Level 12)'},
                                                            'line3':{'en':' Passive - Cruel Recovery - You may gain a temporary hit point boost when you hit an enemy. (Level 16)'},
                                                            'line4':{'en':' Passive - Slasher\'s Mark - Your attacks mark the person they hit. (Level 20)'}}},
                            'Rogue':{       'Daggermaster':{'line1':{'en':' Passive - Deadly Precision - Your pistols have a high critical chance. (Level 11)'},
                                                            'line2':{'en':' Passive - Deadly Meditation - Your pistols all deal increased amounts of damage. (Level 12)'},
                                                            'line3':{'en':' Passive - Deadly Advantage - When you score a critical hit you also deal sneak attack damage. (Level 16)'},
                                                            'line4':{'en':' Passive - Deep Wound - Your pistols cause damage over time to your victim. (Level 20)'}},
                                            'Master Infiltrator':{'line1':{'en':' Passive - Skillful Infiltrator - You appear as one of the enemy. (Level 11)'},
                                                                'line2':{'en':' Command - Impossible to Catch - escape - Become invisible for a short time. (Level 12)'},
                                                                'line3':{'en':' Triggered - Invisible Infiltrator - When you kill an enemy or score a critical hit you become invisible for a short time. (Level 16)'},
                                                                'line4':{'en':' Passive - Painful Puncture - Your attacks may cause on going damage to your victim. (Level 20)'}},
                                            'Shadow Assassin':{ 'line1':{'en':' Passive - Shadow Assassin\'s Riposte - Deal damage to any person that hits you. (Level 11)'},
                                                                'line2':{'en':' Passive - Bad Idea, Friend - Take greatly reduced damage the first time each person attacks you. (Level 12)'},
                                                                'line3':{'en':' Triggered - Bloody Evisceration - Deal extra sneak attack damage to bloodied victims. (Level 16)'},
                                                                'line4':{'en':' Passive - Final Blow - When you hit a bloodied target your attack may do 5x damage. (Level 20)'}}},
                            'Warlock':{     'Doomsayer':{   'line1':{'en':' Passive - Doomsayer\'s Proclamation - Nearby enemies have never vision shaken. (Level 11)'},
                                                            'line2':{'en':' Command - Fate\'s Entwined - fate - Damage your target, then for the next 6 seconds when your are damaged that target takes half that much. (Level 12)'},
                                                            'line3':{'en':' Passive - Doomsayer\'s Oath - All your warlock skills deal extra damage while you are bloodied. (Level 16)'},
                                                            'line4':{'en':' Command - Long Fall into Darkness - fall - Damage and stun your target. (Level 20)'}},
                                            'Feytouched':{  'line1':{'en':' Command - Will of the Feywild - will - Damage your target and then cause them to attack their nearest ally. (Level 11)'},
                                                            'line2':{'en':' Triggered - Twilight Teleport - When you kill someone teleport to where they where. (Level 12)'},
                                                            'line3':{'en':' Triggered - Patron\'s Favor - When you kill an enemy you gain a short speed boost. (Level 16)'},
                                                            'line4':{'en':' Command - Whispers of the Fey - whispers - All nearby enemies make an attack against their closest ally. (Level 20)'}},
                                            'Life-Stealer':{'line1':{'en':' Triggered - Collect Life Spark - Collect your victim\'s life spark when you kill them, life sparks increase your movement. (Level 11)'},
                                                            'line2':{'en':' Command - Soul Scorch - soul - Damage and maybe burn your target, deals bonus damage based on the number of life sparks you have. (Level 12)'},
                                                            'line3':{'en':' Passive - Sustain Life Spark - Gain regeneration based on the number of life sparks you have. (Level 16)'},
                                                            'line4':{'en':' Command - Soultheft - soultheft - Damage your target, if this attack kills them you gain two life sparks instead of one. (Level 20)'}}},
                            'Warlord':{     'Battle Captain':{'line1':{'en':' Passive - Cry Havoc - You and your allies first attacks for the round deal extra damage. (Level 11)'},
                                                            'line2':{'en':' Passive - Force Retreat - Your attack may push back your target and those around them. (Level 12)'},
                                                            'line3':{'en':' Passive - Battle Inspiration - When you use your healing word power on another person they gain a short speed boost. (Level 16)'},
                                                            'line4':{'en':' Passive - Cunning Flurry - Your attacks may stun your target. (Level 20)'}},
                                            'Knight Veteran':{'line1':{'en':' Passive - Tough as Nails - You gain an extra healing surge, when you surge you heal extra based on your Constitution score. (Level 11)'},
                                                            'line2':{'en':' Passive - Honor and Glory - All nearby allies deal extra damage with their attacks. (Level 12)'},
                                                            'line3':{'en':' Passive - Slash and Press - When you attack all nearby enemeies are pushed backwards. (Level 16)'},
                                                            'line4':{'en':' Command - Control the Field - control - Mark all nearby enemies, then deal on going damage to them. (Level 20)'}},
                                            'Sword Marshal':{'line1':{'en':' Passive - Disciplined Blade - You have a higher chance to score a critical hit. (Level 11)'},
                                                            'line2':{'en':' Passive - Sword Marshal\'s Boon - When you use your healing word on an ally it also heals you. (Level 12)'},
                                                            'line3':{'en':' Trigger - Skewer the Weak - When you score a critical hit you also weaken the target. (Level 16)'},
                                                            'line4':{'en':' Passive - Diamond Blade of Victory - Your attacks deal increased damage based on how many allies are near you. (Level 20)'}}},
                            'Wizard':{      'Battle Mage':{ 'line1':{'en':' Trigger - Arcane Riposte - When you dodge an attack you deal damage to the person that tried to hurt you. (Level 11)'},
                                                            'line2':{'en':' Trigger - Arcane Rejuvenation - When you drop below 25% health you burn a healing surge automatically. (Level 12)'},
                                                            'line3':{'en':' Trigger - Battle Edge - When you become bloodied your spell cool down is reset. (Level 16)'},
                                                            'line4':{'en':' Command - Closing Spell - closing - Your target and all those around them are damaged, bloodied targets take increased damage. (Level 20)'}},
                                            'Blood Mage':{  'line1':{'en':' Passive - Bolstering Blood - While you are not bloodied all your spells deal extra damage to you and your target(s). (Level 11)'},
                                                            'line2':{'en':' Command - Blood Pulse - pulse - All nearby enemies are damaged and then are slowed. (Level 12)'},
                                                            'line3':{'en':' Triggered - Burning Blood - When you use a healing surge all nearby enemies take damage and might catch fire. (Level 16)'},
                                                            'line4':{'en':' Command - Destructive Salutation - destructive - Damage, stun, and cause on going damage to your target and those around them. (Level 20)'}},
                                            'Spellstorm Mage':{ 'line1':{'en':' Command - Storm Cage - cage - Damage and then put a cage around your target, they take great damage if they walk through it. (Level 11)'},
                                                                'line2':{'en':' Command - Sudden Storm - sudden - Slow your target and all those around them . (Level 12)'},
                                                                'line3':{'en':' Triggered - Storm Fury - When you become bloodied you deal damage to all nearby enemies based on your wisdom modifier. (Level 16)'},
                                                                'line4':{'en':' Command - Maelstorm of Chaos - chaos - Damage all surrounding enemies and then swap around the postions they are all in. (Level 20)'}}}}}
Class_List = ['Cleric','Fighter','Paladin','Ranger','Rogue','Warlock','Warlord','Wizard']
Ability_List = ['Strength','Constitution','Dexterity','Intelligence','Wisdom','Charisma']
Ability_Increases = [4, 8, 12, 16, 20, 24, 28]
Ability_Infos = {'cstrike':{'Constitution':{'line1':{'en':' Increases Starting Health'},
                                            'line2':{'en':' Increased Number of Healing Surges'}},
                            'Charisma':{'line1':{'en':' Increases the cash you spawn with.'}},
                            'Strength':{'line1':{'en':' Increases the damage you deal with attacks.'}},
                            'Dexterity':{'line1':{'en':' If higher than your intelligence gives a chance to avoid damage from an attack.'}},
                            'Intelligence':{'line1':{'en':' If higher than your dexterity gives a chance to avoid damage from an attack.'}},
                            'Wisdom':{}},
                'pvkii':{'Constitution':{'line1':{'en':' Increases Starting Health'},
                                            'line2':{'en':' Increased Number of Healing Surges'}},
                            'Charisma':{},
                            'Strength':{'line1':{'en':' Increases the damage your meele attacks do.'}},
                            'Dexterity':{'line1':{'en':' If higher than your intelligence gives a chance to avoid damage from an attack.'}},
                            'Intelligence':{'line1':{'en':' If higher than your dexterity gives a chance to avoid damage from an attack.'}},
                            'Wisdom':{}}}
Feats = {'Backstabber':{'requirements':{'abilities':{}, 'classes':{'Rogue':1}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Dwarven Weapon Training':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Dwarf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Durable':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Eladrin Soldier':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Eladrin'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Fast Runner':{'requirements':{'abilities':{'Constitution':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Healing Hands':{'requirements':{'abilities':{}, 'classes':{'Paladin':2}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Light Step':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Elf','Half Elf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Long Jumper':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Power Attack':{'requirements':{'abilities':{'Strength':15}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Toughness':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Alertness':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Dodge Giants':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Dwarf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Expand Spellbook':{'requirements':{'abilities':{}, 'classes':{'Wizard':1}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Group Insight':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Half Elf'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Hellfire Blood':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Tiefling'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Improved Initiative':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Lost in the Crowd':{'requirements':{'abilities':{}, 'classes':{}, 'races':['Halfling'], 'feats':[], 'level':0, 'banned classes':[]}},
        'Press the Advantage':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Weapon Focus':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},
        'Initiate of the Faith':{'requirements':{'abilities':{'Wisdom':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Cleric','Warlord']}},
        'Sneak of Shadows':{'requirements':{'abilities':{'Dexterity':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Rogue']}},
        'Pact Initiate':{'requirements':{'abilities':{'Charisma':13}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':['Warlock']}},
        'Stead Fast':{'requirements':{'abilities':{}, 'classes':{}, 'races':[], 'feats':[], 'level':0, 'banned classes':[]}},}
Feat_Infos = {'cstrike':{'Alertness':{'list':['line1'],
                    'dict':{'line1':{'en':' Rogues are unable to sneak attack you.'}}},
                    'Stead Fast':{'list':['line1'],
                    'dict':{'line1':{'en':' You are unable to be pushed around.'}}},
                    'Dodge Giants':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Dwarf'},
                            'line2':{'en':' Have a chance to take no damage from \'normal size\' races'}}},
                    'Expand Spellbook':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Wizard'},
                            'line2':{'en':' Reduces the cooldown timer on all of your spells.'}}},
                    'Group Insight':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Half Elf'},
                            'line2':{'en':' You take reduced damage based on the number of nearby allies you have.'}}},
                    'Hellfire Blood':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Tiefling'},
                            'line2':{'en':' When bloodied your attacks may set fire to the person they hit.'}}},
                    'Improved Initiative':{'list':['line1'],
                    'dict':{'line1':{'en':' You gain a short speed boost at the start of a round.'}}},
                    'Lost in the Crowd':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Halfling'},
                            'line2':{'en':' You become harder to see when you have two or more other people near you.'}}},
                    'Press the Advantage':{'list':['line1'],
                    'dict':{'line1':{'en':' When you score a critical hit you also slow the victim.'}}},
                    'Weapon Focus':{'list':['line1'],
                    'dict':{'line1':{'en':' Gain increased damage with the selected weapon group.'}}},
                    'Initiate of the Faith':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Wisdom 13'},
                            'line2':{'en':' Gain acess to the Cleric\'s word command with a longer cooldown duration.'}}},
                    'Sneak of Shadows':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Dexterity 13'},
                            'line2':{'en':' Walking or ducking causes you to become harder to see.'}}},
                    'Pact Initiate':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Charisma 13'},
                            'line2':{'en':' Gain acess to the Warlock\'s blast command with a longer cooldown duration.'}}},
                    'Backstabber':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Rogue'},
                            'line2':{'en':' Increases the damage done with your Sneak Attack.'}}},
                    'Durable':{'list':['line1'],
                    'dict':{'line1':{'en':' Gain 2 more healing surges per spawn'}}},
                    'Dwarven Weapon Training':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Dwarf'},
                            'line2':{'en':' Gain increased damage with all rifles.'}}},
                    'Eladrin Soldier':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Eladrin'},
                            'line2':{'en':' Gain increased damage with all SMGs.'}}},
                    'Fast Runner':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Consititution 13'},
                            'line2':{'en':' Gain an increased movement speed'}}},
                    'Healing Hands':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Paladin (Level 2)'},
                            'line2':{'en':' Add your charisma score to the amount your Lay on Hands heals.'}}},
                    'Light Step':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Elf or Half Elf'},
                            'line2':{'en':' Gain an increased movement speed'}}},
                    'Long Jumper':{'list':['line1'],
                    'dict':{'line1':{'en':' Jump farthur.'}}},
                    'Power Attack':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Strength 15'},
                            'line2':{'en':' Gain a 10% damage boost with all weapons.'}}},
                    'Toughness':{'list':['line1'],
                    'dict':{'line1':{'en':' Your maximum health is increased.'}}}},
            'pvkii':{'Alertness':{'list':['line1'],
                    'dict':{'line1':{'en':' Rogues are unable to sneak attack you.'}}},
                    'Stead Fast':{'list':['line1'],
                    'dict':{'line1':{'en':' You are unable to be pushed around.'}}},
                    'Dodge Giants':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Dwarf'},
                            'line2':{'en':' Have a chance to take no damage from \'normal size\' races'}}},
                    'Expand Spellbook':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Wizard'},
                            'line2':{'en':' Reduces the cooldown timer on all of your spells.'}}},
                    'Group Insight':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Half Elf'},
                            'line2':{'en':' You take reduced damage based on the number of nearby allies you have.'}}},
                    'Hellfire Blood':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Tiefling'},
                            'line2':{'en':' When bloodied your attacks may set fire to the person they hit.'}}},
                    'Improved Initiative':{'list':['line1'],
                    'dict':{'line1':{'en':' You gain a short speed boost at the start of a round.'}}},
                    'Lost in the Crowd':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Halfling'},
                            'line2':{'en':' You become harder to see when you have two or more other people near you.'}}},
                    'Press the Advantage':{'list':['line1'],
                    'dict':{'line1':{'en':' When you score a critical hit you also slow the victim.'}}},
                    'Weapon Focus':{'list':['line1'],
                    'dict':{'line1':{'en':' Gain increased damage with the selected weapon group.'}}},
                    'Initiate of the Faith':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Wisdom 13'},
                            'line2':{'en':' Gain acess to the Cleric\'s word command with a longer cooldown duration.'}}},
                    'Sneak of Shadows':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Dexterity 13'},
                            'line2':{'en':' Walking or ducking causes you to become harder to see.'}}},
                    'Pact Initiate':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Charisma 13'},
                            'line2':{'en':' Gain acess to the Warlock\'s blast command with a longer cooldown duration.'}}},
                    'Backstabber':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Rogue'},
                            'line2':{'en':' Increases the damage done with your Sneak Attack.'}}},
                    'Durable':{'list':['line1'],
                    'dict':{'line1':{'en':' Gain 2 more healing surges per spawn'}}},
                    'Dwarven Weapon Training':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Dwarf'},
                            'line2':{'en':' Gain increased damage with all axes.'}}},
                    'Eladrin Soldier':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Eladrin'},
                            'line2':{'en':' Gain increased damage with all swords.'}}},
                    'Fast Runner':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Consititution 13'},
                            'line2':{'en':' Gain an increased movement speed'}}},
                    'Healing Hands':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Class - Paladin (Level 2)'},
                            'line2':{'en':' Add your charisma score to the amount your Lay on Hands heals.'}}},
                    'Light Step':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Race - Elf or Half Elf'},
                            'line2':{'en':' Gain an increased movement speed'}}},
                    'Long Jumper':{'list':['line1'],
                    'dict':{'line1':{'en':' Jump farthur.'}}},
                    'Power Attack':{'list':['line1','line2'],
                    'dict':{'line1':{'en':' Required Stat - Strength 15'},
                            'line2':{'en':' Gain increased damage with all meele weapons.'}}},
                    'Toughness':{'list':['line1'],
                    'dict':{'line1':{'en':' Your maximum health is increased.'}}}}}
Feat_List = ['Alertness',
            'Backstabber',
            'Dwarven Weapon Training',
            'Dodge Giants',
            'Durable',
            'Eladrin Soldier',
            'Expand Spellbook',
            'Fast Runner',
            'Group Insight',
            'Healing Hands',
            'Hellfire Blood',
            'Initiate of the Faith',
            'Improved Initiative',
            'Light Step',
            'Long Jumper',
            'Lost in the Crowd',
            'Pact Initiate',
            'Power Attack',
            'Press the Advantage',
            'Sneak of Shadows',
            'Stead Fast',
            'Toughness',
            'Weapon Focus']
Feat_Increases = [2, 4, 6, 8, 10, 11, 12, 14, 16, 18, 20, 21, 22, 24, 26, 28, 30]
Characters = {}
Public_Characters = []
#                     Level : Xp Needed to Obtain it
Levels = {2:1000,
    3:2250,
    4:3750,
    5:5500,
    6:7500,
    7:10000,
    8:13000,
    9:16500,
    10:20500,
    11:25500,
    12:31500,
    13:38500,
    14:46500,
    15:56500,
    16:68500,
    17:82500,
    18:98500,
    19:118500,
    20:142500,
    21:170500,
    22:202500,
    23:244000,
    24:295000,
    25:355500,
    26:425500,
    27:515500,
    28:625500,
    29:755500,
    30:905500}
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - Begin Load')
    global text, Characters, gamedir, game
    text = langlib.Strings(es.getAddonPath('dnds') + '/strings.ini')
    str_path = es.getAddonPath('dnds') + '/Characters.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        Characters = cPickle.load(file_users)
        file_users.close()
        for c in Characters:
            if Characters[c]['password'] == 'public':
                Public_Characters.append(c)
    gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
    if gamedir in ['cstrike','hl2mp','dod','pvkii','tf']:
        es.load('dnds/games/%sdnds'%gamedir)
    gamevar = None
    if gamedir == 'cstrike':
        game = 'Counter-Strike: Source'
        '''import cstrikednds
        from cstrikednds import cstrikednds
        gamevar = cstrikednds'''
    elif gamedir == 'hl2mp':
        game = 'Half Life 2 Deathmatch'
        '''import hl2mpdnds
        from hl2mpdnds import hl2mpdnds
        gamevar = hl2mpdnds'''
    elif gamedir == 'dod':
        game = 'Day of Defeat: Source'
        '''import doddnds
        from doddnds import doddnds
        gamevar = doddnds'''
    elif gamedir == 'pvkii':
        game = 'Pirates, Vikings, and Knights'
        '''import pvkiidnds
        from pvkiidnds import pvkiidnds
        gamevar = pvkiidnds'''
    elif gamedir == 'tf':
        game = 'Team Fortress 2'
        '''import tfdnds
        from tfdnds import tfdnds
        gamevar = tfdnds'''
    else:
        game = 'Unknown'
        es.dbgmsg(0, '[Dungeons and Dragons] - Game is Unkown - Request support for this game @ http://featurelist.org/dnds')
    es.dbgmsg(0, '[Dungeons and Dragons] - Directory %s'%gamedir)
    es.dbgmsg(0, '[Dungeons and Dragons] - Game %s'%game)
    if not es.exists('saycommand', 'dnd'):
        es.regsaycmd('dnd', 'dnds/Command')
    if not es.exists('clientcommand', 'dnd'):
        es.regclientcmd('dnd', 'dnds/Command')
    ServerVars = {'dnds_KillXp':65,
                    'dnds_Debug':0}
    for x in ServerVars:
        es.ServerVar(x).set(ServerVars[x])
    if os.path.isfile(es.getAddonPath('dnds')+'/dnds.cfg'):
        es.server.queuecmd('es_xmexec ../addons/eventscripts/dnds/dnds.cfg')
    else:
        es.dbgmsg(0, '[Dungeons and Dragons] - Cannot find the dnds.cfg file! - Using default values...')
    DemoCharacters()
    LoopBlock()
    Check()
    Menus()
    es.loadevents('declare', 'addons/eventscripts/dnds/events.res')
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.addons.registerTickListener(Ticker)
    es.addons.registerClientCommandFilter(_cc_filter)
    es.dbgmsg(0, '[Dungeons and Dragons] - Load Finished')
#builds our demo characters, added into it's own method to allow backwards support for Version < 0.1.7 and for customization
def DemoCharacters():
    Characters['Cleric'] = {'creator':'J3ff Hoogland',
                            'race':'Elf',
                            'classes':{'Cleric':{'level':5}},
                            'feats':['Alertness','Light Step','Fast Runner'],
                            'abilities':{'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':14,
                                        'Intelligence':10,
                                        'Wisdom':18,
                                        'Charisma':14},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Fighter'] = {'creator':'J3ff Hoogland',
                            'race':'Dwarf',
                            'classes':{'Fighter':{'level':5}},
                            'feats':['Dwarven Weapon Training','Improved Initiative','Toughness'],
                            'abilities':{'Strength':14,
                                        'Constitution':18,
                                        'Dexterity':14,
                                        'Intelligence':10,
                                        'Wisdom':14,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Paladin'] = {'creator':'J3ff Hoogland',
                            'race':'Half Elf',
                            'classes':{'Paladin':{'level':5}},
                            'feats':['Durable','Healing Hands','Group Insight'],
                            'abilities':{'Strength':16,
                                        'Constitution':16,
                                        'Dexterity':12,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':16},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Ranger'] = {'creator':'J3ff Hoogland',
                            'race':'Halfling',
                            'classes':{'Ranger':{'level':5}},
                            'feats':['Press the Advantage','Fast Runner','Lost in the Crowd'],
                            'abilities':{'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':18,
                                        'Intelligence':12,
                                        'Wisdom':14,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':'archer',
                            'paragon path':None}
    Characters['Rogue'] = {'creator':'J3ff Hoogland',
                            'race':'Human',
                            'classes':{'Rogue':{'level':5}},
                            'feats':['Improved Initiative','Backstabber','Long Jumper','Fast Runner'],
                            'abilities':{'Strength':12,
                                        'Constitution':14,
                                        'Dexterity':18,
                                        'Intelligence':14,
                                        'Wisdom':12,
                                        'Charisma':10},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Warlock'] = {'creator':'J3ff Hoogland',
                            'race':'Tiefling',
                            'classes':{'Warlock':{'level':5}},
                            'feats':['Hellfire Blood','Durable','Fast Runner'],
                            'abilities':{'Strength':12,
                                        'Constitution':14,
                                        'Dexterity':12,
                                        'Intelligence':16,
                                        'Wisdom':10,
                                        'Charisma':18},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Warlord'] = {'creator':'J3ff Hoogland',
                            'race':'Dragonborn',
                            'classes':{'Warlord':{'level':5}},
                            'feats':['Power Attack','Durable','Toughness'],
                            'abilities':{'Strength':18,
                                        'Constitution':12,
                                        'Dexterity':12,
                                        'Intelligence':14,
                                        'Wisdom':10,
                                        'Charisma':16},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
    Characters['Wizard'] = {'creator':'J3ff Hoogland',
                            'race':'Eladrin',
                            'classes':{'Wizard':{'level':5}},
                            'feats':['Expand Spellbook','Alertness','Toughness'],
                            'abilities':{'Strength':10,
                                        'Constitution':14,
                                        'Dexterity':16,
                                        'Intelligence':18,
                                        'Wisdom':12,
                                        'Charisma':12},
                            'password':'demo',
                            'xp':5500,
                            'level':5,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
#End Load Methods
#Begin unload methods
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload Start')
    for id in es.getUseridList():
        Unsend(id)
    if gamedir != 'cstrike' and gamedir != 'dod':
        es.addons.unregisterTickListener(Ticker)
    for d in Players['delay list']:
        gamethread.cancelDelayed(d)
    for id in Players:
        if id != 'delay list':
            for d in Players[id]['delay list']:
                gamethread.cancelDelayed(d)
    for d in ['dnds loop', 'dnds check']:
        gamethread.cancelDelayed(d)
    str_path = open(es.getAddonPath('dnds') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    es.unload('dnds/games/%sdnds'%gamedir)
    es.addons.unregisterClientCommandFilter(_cc_filter)
    es.dbgmsg(0, '[Dungeons and Dragons] - Unload End')
#end unload methods
#Begin global methods
def defaultBot(userid):
    Players[self.userid] = {}
    Players[self.userid]['character'] = None
    Players[self.userid]['pending'] = None
    Players[self.userid]['characters list'] = []
    Players[self.userid]['delay list'] = []
    Players[self.userid]['gravity'] = 1.0
    Players[self.userid]['long jump'] = 1.0
#My range() function beacuse the built in one does not work how I like
def range(start=0, stop=0, step=1):
    if not stop:
        stop = start
        start = 0
    mylist = []
    while start < stop:
        mylist.append(start)
        start += step
    return mylist
'''My Range Method:
    for i in range(.5, 8, .5): print i

    0.5
    1.0
    1.5
    2.0
    2.5
    3.0
    3.5
    4.0
    4.5
    5.0
    5.5
    6.0
    6.5
    7.0
    7.5

    Built in:
    for i in range(.5, 8, .5): print i


    Warning (from warnings module):
      File "__main__", line 1
    DeprecationWarning: integer argument expected, got float

    Traceback (most recent call last):
      File "<pyshell#1>", line 1, in <module>
        for i in range(.5, 8, .5): print i
    ValueError: range() step argument must not be zero'''
#Blind a user
def Blind(userid, delay, alpha=255):
    es.server.queuecmd('est_Fade %s 2 0 %s 0 0 0 %s'%(userid, delay, alpha))
def Speed(userid, amount):
    getPlayer(userid)['Player'].key['speed'] += amount
    getPlayer(userid)['playerlib'].set('speed', getPlayer(userid)['Player'].key['speed'])
#A few simple effects
def Beam(player1,player2,life,r,g,b):
    #Sends a random beam connecting the two players with the given RGB color values
    choice = random.randint(1, 2)
    if choice == 1:
        Beam1(player1,player2,life,r,g,b)
    #Didnt like how this beam looks
    #elif choice == 2:
    #    Beam2(player1,player2,life,r,g,b)
    elif choice == 2:
        Beam3(player1,player2,life,r,g,b)
def Beam1(player1,player2,life,r,g,b):
    # Connects 2 users together via a normal beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="sprites/lgtning.vmt", seconds=life, red=r, green=g, blue=b)
def Beam2(player1,player2,life,r,g,b):
    # Connects 2 users together via a more rough beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="effects/tp_eyefx/tpeye3.vmt", seconds=life, red=r, green=g, blue=b)
def Beam3(player1,player2,life,r,g,b):
    # Connects 2 users together via a laser beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    if gamedir != 'pvkii' and game != 'Unknown':
        es.server.queuecmd('est_effect 3 #a 0 materials/sprites/laser.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
    else:
        effectlib.drawLine((x,y,z+30), (x1,y1,z1+30), model="materials/sprites/laser.vmt", seconds=life, red=r, green=g, blue=b)
#Returns the ability mod of a given score value
def statMod(userid, stat):
    if getPlayer(userid)['Character'].key['abilities'][stat]:
        return (getPlayer(userid)['Character'].key['abilities'][stat]-10)/2
    return 0
#Checks to see if any of a user's ability scores are 0
def statCheck(userid):
    abilities = getPlayer(userid)['Character'].key['abilities']
    for a in Ability_List:
        if not abilities[a]:
            return None
            break
    return 1
#Used to handle all acessing of classes (Menu, Character, and Player)
__Players = {}
def getPlayer(userid):
    #report('%s is running through the getPlayer block'%es.getplayername(userid))
    userid = int(userid)
    if es.exists('userid', userid):
        if userid not in __Players:
            report('Creating a user key for %s for the 3 global classes'%es.getplayername(userid))
            __Players[userid] = {'Player':Player(userid),'Menu':MenuSelect(),'Character':Character(userid),'playerlib':playerlib.getPlayer(userid)}
        else:
            if not Players[userid]['character']:
                Players[userid]['character'] = 'Fighter'
            __Players[userid]['Character'].key = Characters[Players[userid]['character']]
        #if es.isbot(userid):
        #    __Players[userid]['Player'].key['character'] = 'Fighter'
        return __Players[userid]
    else:
        return None
def delPlayer(userid):
    userid = int(userid)
    #global __Players
    if userid in __Players:
        del __Players[userid]
        gc.collect()
#End global methods
#Begin Classes
def Menus():
    global back, exit, yes, no
    back = {'en': '-> 9. Back',
            'de': '-> 9. Zuruck',
            'fr': '-> 9. Retour'}
    exit = {'en': '0. - Exit',
            'de': '0. - SchlieBen',
            'fr': '0. - Fermer'}
    yes =  {'en': '-> 6. Yes',
            'de': '',
            'fr': ''}
    no =   {'en': '-> 7. No',
            'de': '',
            'fr': ''}
    a = popuplib.create('main menu')
    b = a.addline
    line1 = {'en':'-{ Dungeons and Dragons Main Menu }-',
            'de': '-{ Dungeons and Dragons Hauptmenu }-',
            'fr': '-{ Dungeons and Dragons Menu principal }-'}
    line2 = {'en':'-> 1. Create Character',
            'de': '-> 1. Erstelle einen Charakter',
            'fr': '-> 1. Creer un Personnage'}
    line3 = {'en':'-> 2. Load Character',
            'de': '-> 2. Lade einen Charakter',
            'fr': '-> 2. Charger un Personnage'}
    line4 = {'en':'-> 3. Current Character Information',
            'de': '-> 3. Aktuelle Charakter Informationen',
            'fr': '-> 3. Information actuel sur Personnage'}
    line5 = {'en':'-> 4. Edit Character Options',
            'de': '',
            'fr': ''}
    line6 = {'en':'-> 5. Delete a Character',
            'de': '',
            'fr': ''}
    line7 = {'en':'-> 6. Information Menu',
            'de': '-> 6. Informations Menu',
            'fr': '-> 6. Information Menu'}
    line8 = {'en':'-> 7. Help Menu',
            'de': '-> 7. Hilfe Menu',
            'fr': '-> 7. Menu d\'Aide'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(line6)
    b(line7)
    b(line8)
    b(exit)
    a.menuselectfb = MenuSelect().MainMenuSelect
    a.submenu(2, 'load menu')
    a.submenu(4, 'edit options')
    a.submenu(6, 'info menu')
    a.submenu(7, 'help menu')
    a.submenu(8, 'main menu')
    a.submenu(9, 'main menu')
    
    a = popuplib.create('edit options')
    b = a.addline
    line1 = {'en':'-{ Dungeons and Dragons Character Options }-'}
    line2 = {'en':'-> 1. Password Current Character'}
    b(line1)
    b(line2)
    b(back)
    b(exit)
    for i in range(2, 9):
        a.submenu(i, 'edit options')
    a.submenu(9, 'main menu')
    a.select(1, MenuSelect().SetPassword)
    
    a = popuplib.create('load menu')
    b = a.addline
    line1 = {'en':'-{ Dungeons and Dragons Load Character Menu }-'}
    line2 = {'en':'-> 1. Personal Characters'}
    line3 = {'en':'-> 2. Demo Characters'}
    line4 = {'en':'-> 3. Passworded Character'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    a.menuselectfb = MenuSelect().LoadMenuSelect
    a.submenu(2, 'demo menu')
    for i in range(3, 9):
        a.submenu(i, 'load menu')
    a.submenu(9, 'main menu')
    
    a = popuplib.create('demo menu')
    b = a.addline
    count = 1
    line1 = {'en':'Select a test character to test out:',
            'de': '',
            'fr': ''}
    b(line1)
    for Class in Class_List:
        b({'en':'-> %s. %s'%(count, Class)})
        count += 1
    b(back)
    b(exit)
    a.submenu(9, 'load menu')
    a.menuselectfb = MenuSelect().DemoCharacterSelect
    
    a = popuplib.create('help menu')
    b = a.addline
    line1 = {'en':'-{ Welcome to a Dungeons and Dragons }-',
             'de':'-{ Willkommen zu Dungeons and Dragons }-',
             'fr':'-{ Bienvenue a Dungeons and Dragons }-'}
    line2 = {'en':'- dnd Command List -',
             'de':'- dnd Befehlsliste -',
             'fr':'- Liste des commandes -'}
    line3 = {'en':'- dnd Menu - A main menu for the mod -',
             'de':'- dnd Menu - Ein Hauptmenu fur die Mod -',
             'fr':'- dnd Menu - Un menu principal pour le mod-'}
    line4 = {'en':'- dnd Create <Character Name> - Start creating your character -',
             'de':'- dnd Create <Charakter Name> - Startet das Erstellen deines Charakters -',
             'fr':'- dnd Create <Character Name> - Creer votre personnage -'}
    line5 = {'en':'- dnd Load <Character Name> - Load a preexisting character -',
             'de':'- dnd Load <Charakter Name> - Ladt einen existierenden Charakter -',
             'fr':'- dnd Load <Character Name> - Charger un personnage preexistant -'}
    line6 = {'en':'- dnd Stats - See what character your are playing -',
             'de':'- dnd Stats - Zeigt deinen Charakter den du spielst -',
             'fr':'- dnd Stats - Voyez ce que votre personnage jouent -'}
    line7 = {'en':'- dnd Info - Displays information about different dnd features -',
             'de':'- dnd Info - Zeigt Informationen uber verschiedene dnd Features -',
             'fr':'- dnd Info - Affiche des informations sur les differentes caracteristiques -'}
    line8 = {'en':'- dnd Help - This Menu -',
             'de':'- dnd Help - Dieses Menu -',
             'fr':'- Menu d\'aide -'}
    line9 = {'en':'-> 9. To Main Menu',
             'de':'-> 9. Zum Hauptmenu',
             'fr':'-> 9. Au menu principal'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(line6)
    b(line7)
    b(line8)
    b(line9)
    b(exit)
    a.submenu(9, 'main menu')
    for i in range(1, 9):
        a.submenu(i, 'help menu')
    
    a = popuplib.create('info menu')
    b = a.addline
    line1 =  {'en':'-{ Dungeons and Dragons Information Menu }-',
             'de':'-{ Dungeons and Dragons Informations Menu }-',
             'fr':'-{ Dungeons and Dragons Information Menu }-'}
    line2 =  {'en':'-> 1. Races',
             'de':'-> 1. Rassen',
             'fr':'-> 1. Races'}
    line3 =  {'en':'-> 2. Classes'}
    line4 =  {'en':'-> 3. Abilities'}
    line5 =  {'en':'-> 4. Feats'}
    line6 =  {'en':'-> 7. General Information'}
    line7 =  {'en':'-> 8. Mod Information'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(line6)
    b(line7)
    b(back)
    b(exit)
    infosubs = {1:'race info',2:'class info',3:'ability info',4:'feat info',5:'info menu',6:'info menu',7:'general info',8:'mod info',9:'main menu'}
    for sub in infosubs:
        a.submenu(sub, infosubs[sub])
    
    a = popuplib.create('paragon info')
    b = a.addline
    line1 = {'en':'Which class\'s paragons would you like to see:'}
    b(line1)
    count = 1
    for Class in Class_List:
        b({'en':'-> %s. %s'%(count, Class)})
        a.submenu(count, '%s paragons'%Class)
        count += 1
    b(back)
    b(exit)
    
    a = popuplib.create('class info')
    b = a.addline
    line1 = {'en':'Select a Class to Learn about:'}
    b(line1)
    count = 1
    for Class in Class_List:
        b({'en':'-> %s. %s'%(count, Class)})
        count += 1
    b(back)
    b(exit)
    a.prepuser = MenuSelect().ClassInfoPrep
    a.menuselectfb = MenuSelect().ClassMenuSelect
    infosubs = {1:'Cleric info',2:'Fighter info',3:'Paladin info',4:'Ranger info',5:'Rogue info',6:'Warlock menu',7:'Warlord info',8:'Wizard info'}
    for sub in infosubs:
        a.submenu(sub, infosubs[sub])
	
    for Class in Class_Infos[gamedir]:
        a = popuplib.create('%s info'%Class)
        b = a.addline
        b('%s Information:'%Class)
        count = 1
        lines = len(Class_Infos[gamedir][Class]['base'])
        while count <= lines:
            b(Class_Infos[gamedir][Class]['base']['line%s'%count])
            count += 1
        if Class != 'Ranger':
            a.submenu(1, '%s powers1'%Class)
            a.submenu(2, '%s powers2'%Class)
            a.submenu(3, '%s powers3'%Class)
        else:
            a.submenu(1, 'Ranger two weapon')
            a.submenu(2, 'Ranger archer')
            a.submenu(3, '%s info'%Class)
        for i in range(5, 8):
            a.submenu(i, '%s info'%Class)
        b(back)
        b(exit)
        a.submenu(9, 'class info')
        a.submenu(4, '%s paragons'%Class)
        a.prepuser = MenuSelect().ClassesInfoPrep
        a.menuselectfb = MenuSelect().ClassesInfoSelect
        if Class != 'Ranger':
            for i in range(1, 4):
                a = popuplib.create('%s powers%s'%(Class, i))
                b = a.addline
                if i == 1:
                    string = '%s Powers Levels 1-5'%Class
                elif i == 2:
                    string = '%s Powers Levels 6-10'%Class
                else:
                    string = '%s Powers Levels 11-20'%Class
                b({'en':string})
                count = 1
                lines = len(Class_Infos[gamedir][Class]['powers%s'%i])
                while count <= lines:
                    b(Class_Infos[gamedir][Class]['powers%s'%i]['line%s'%count])
                    count += 1
                for xi in range(1, 9):
                    a.submenu(xi, '%s powers%s'%(Class, i))
                a.submenu(9, '%s info'%Class)
                b(back)
                b(exit)
        else:
            for i in range(1, 4):
                for kind in ['two weapon', 'archer']:
                    a = popuplib.create('%s %s powers%s'%(Class, kind, i))
                    b = a.addline
                    if i == 1:
                        string = '%s %s Powers Levels 1-5'%(Class, kind)
                    elif i == 2:
                        string = '%s %s Powers Levels 6-10'%(Class, kind)
                    else:
                        string = '%s %s Powers Levels 11-20'%(Class, kind)
                    b({'en':string})
                    count = 1
                    lines = len(Class_Infos[gamedir][Class]['%s powers%s'%(kind, i)])
                    while count <= lines:
                        b(Class_Infos[gamedir][Class]['%s powers%s'%(kind, i)]['line%s'%count])
                        count += 1
                    for xi in range(1, 9):
                        a.submenu(xi, '%s %s powers%s'%(Class, kind, i))
                    a.submenu(9, '%s %s'%(Class, kind))
                    b(back)
                    b(exit)
    
    a = popuplib.create('Ranger two weapon')
    b = a.addline
    line1 = {'en':'Two Weapon Fighting Powers:'}
    line2 = {'en':'-> 1. Levels 1-5'}
    line3 = {'en':'-> 2. Levels 6-10'}
    line4 = {'en':'-> 3. Levels 11-20'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    a.submenu(1, 'Ranger two weapon powers1')
    a.submenu(2, 'Ranger two weapon powers2')
    a.submenu(3, 'Ranger two weapon powers3')
    for i in range(4, 9):
        a.submenu(i, 'Ranger two weapon')
    a.submenu(9, 'Ranger info')
    
    a = popuplib.create('Ranger archer')
    b = a.addline
    line1 = {'en':'Archer Powers:'}
    line2 = {'en':'-> 1. Levels 1-5'}
    line3 = {'en':'-> 2. Levels 6-10'}
    line4 = {'en':'-> 3. Levels 11-20'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    a.submenu(1, 'Ranger archer powers1')
    a.submenu(2, 'Ranger archer powers2')
    a.submenu(3, 'Ranger archer powers3')
    for i in range(4, 9):
        a.submenu(i, 'Ranger archer')
    a.submenu(9, 'Ranger info')
    
    a = popuplib.create('general info')
    b = a.addline
    line1 = {'en':'- { Dungeons and Dragons General Information } -'}
    line2 = {'en':'-> 1. Custom Commands'}
    line3 = {'en':'-> 2. Passworded Characters'}
    line4 = {'en':'-> 3. Demo Characters'}
    line5 = {'en':'-> 4. Terms'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(back)
    b(exit)
    for i in range(5, 9):
        a.submenu(i, 'general info')
    a.submenu(1, 'custom info')
    a.submenu(2, 'password info')
    a.submenu(3, 'demo info')
    a.submenu(4, 'terms info')
    a.submenu(9, 'info menu')
    
    a = popuplib.create('terms info')
    b = a.addline
    line1 = {'en':'- { Dungeons and Dragons Glossary} -'}
    line2 = {'en':' Bloodied - You are \'bloodied\' when your health is below half.'}
    line3 = {'en':' Weakened - Players that are weakened deal less damage.'}
    line4 = {'en':' Marked - Marking a player causes them to deal less damage to people other than yourself.'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    for i in range(1, 9):
        a.submenu(i, 'terms info')
    a.submenu(9, 'general info')
    
    a = popuplib.create('demo info')
    b = a.addline
    line1 = {'en':'- Demo Characters -'}
    line2 = {'en':'What are Demo Characters:'}
    line3 = {'en':' - Characters that come pre-built at level 5'}
    line4 = {'en':' - They do not gain Xp or Level up'}
    line5 = {'en':' - Any number of people may be playing the same demo character at the same time'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(back)
    b(exit)
    for i in range(1, 9):
        a.submenu(i, 'demo info')
    a.submenu(9, 'general info')
    
    a = popuplib.create('custom info')
    b = a.addline
    line1 = {'en':'- { Dungeons and Dragons Custom Commands } -'}
    line2 = {'en':' Commands in Class/Race Infos - Format'}
    line3 = {'en':' - Command: <name> - <command> - <description>'}
    line4 = {'en':' +wind - Hold to use a healing surge'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    for i in range(1, 9):
        a.submenu(i, 'custom info')
    a.submenu(9, 'general info')
    
    a = popuplib.create('password info')
    b = a.addline
    line1 = {'en':'Reasons to Password your Character(s):'}
    line2 = {'en':' - A passworded character can be loaded from any steam account using'}
    line3 = {'en':' - dnd load <character name> - and then - dnd passwordenter <password> -'}
    line4 = {'en':' - Share your steam account? Don\'t have to share your characters'}
    line5 = {'en':'Once you password a character:'}
    line6 = {'en':' - Anyone with it\'s name and password can loaded it'}
    line7 = {'en':' - Each character can only be loaded by one person at a time'}
    line8 = {'en':' - You cannot change or remove the password'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(line6)
    b(line7)
    b(line8)
    b(back)
    b(exit)
    for i in range(1, 9):
        a.submenu(i, 'password info')
    a.submenu(9, 'general info')
    
    a = popuplib.create('mod info')
    b = a.addline
    line1 = {'en':'- { Mod Information } -'}
    line2 = {'en':' Download/Info Link: www.DnDSource.net'}
    line3 = {'en':' Request Features: http://featurelist.org/dnds'}
    line4 = {'en':' Created By: J3ff Hoogland'}
    line5 = {'en':' Contact Email: Jeff@hobhq.com'}
    line6 = {'en':' AIM/Steam Contact: beastrace91'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(line5)
    b(line6)
    b(back)
    b(exit)
    for i in range(1, 9):
        a.submenu(i, 'mod info')
    a.submenu(9, 'info menu')
    
    a = popuplib.create('feat info')
    b = a.addline
    line1 =  {'en':'-{ Dungeons and Dragons Feat Information }-'}
    line2 =  {'en':'-> 1. Feats I Have'}
    line3 =  {'en':'-> 2. Feats I Can Learn'}
    line4 =  {'en':'-> 3. Feats I Can\'t Learn'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    b(back)
    b(exit)
    a.prepuser = MenuSelect().FeatInfoPrep
    a.menuselectfb = MenuSelect().FeatInfoSelect
    for i in range(4, 9):
        a.submenu(i, 'feat info')
    a.submenu(9, 'info menu')
    
    a = popuplib.create('race info')
    b = a.addline
    line1 =  {'en':'Select a Race to Learn about:',
             'de':'Wahle eine Rasse um mehr zu erfahren:',
             'fr':'Selectionner une race pour en apprendre davantage:'}
    b(line1)
    count = 1
    for race in Race_List:
        b({'en':'-> %s. %s'%(count, race)})
        count += 1
    b(back)
    b(exit)
    racesubs = {1:'dragonborn info',2:'dwarf info',3:'eladrin info',4:'elf info',5:'half elf info',6:'halfling info',7:'human info',8:'tiefling info'}
    for race in racesubs:
        a.submenu(race, racesubs[race])
    a.prepuser = MenuSelect().RaceInfoPrep
    a.menuselectfb = MenuSelect().RaceInfoSelect
    
    a = popuplib.create('dragonborn info')
    b = a.addline
    line1 = {'en':'Dragonborn Information:'}
    line2 = {'en':' Stat Increases - Strength +2 and Charisma +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'dragonborn info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().DragonbornPrep
    a.menuselect = MenuSelect().DragonbornSelect
    
    a = popuplib.create('dwarf info')
    b = a.addline
    line1 = {'en':'Dwarf Information:'}
    line2 = {'en':' Stat Increases - Constitution +2 and Wisdom +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'dwarf info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().DwarfPrep
    a.menuselect = MenuSelect().DwarfSelect
    
    a = popuplib.create('eladrin info')
    b = a.addline
    line1 = {'en':'Eladrin Information:'}
    line2 = {'en':' Stat Increases - Dexterity +2 and Intelligence +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'eladrin info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().EladrinPrep
    a.menuselect = MenuSelect().EladrinSelect
    
    a = popuplib.create('elf info')
    b = a.addline
    line1 = {'en':'Elf Information:'}
    line2 = {'en':' Stat Increases - Dexterity +2 and Wisdom +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'elf info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().ElfPrep
    a.menuselect = MenuSelect().ElfSelect
    
    a = popuplib.create('half elf info')
    b = a.addline
    line1 = {'en':'Half Elf Information:'}
    line2 = {'en':' Stat Increases - Constitution +2 and Charisma +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'half elf info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().HalfElfPrep
    a.menuselect = MenuSelect().HalfElfSelect
    
    a = popuplib.create('halfling info')
    b = a.addline
    line1 = {'en':'Halfling Information:'}
    line2 = {'en':' Stat Increases - Dexterity +2 and Charisma +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'halfling info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().HalflingPrep
    a.menuselect = MenuSelect().HalflingSelect
    
    a = popuplib.create('human info')
    b = a.addline
    line1 = {'en':'Human Information:'}
    line2 = {'en':' Stat Increases - Any Stat +2'}
    line3 = {'en':' Gain an extra feat at first level'}
    b(line1)
    b(line2)
    b(line3)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'human info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().HumanPrep
    a.menuselect = MenuSelect().HumanSelect
    
    a = popuplib.create('tiefling info')
    b = a.addline
    line1 = {'en':'Tiefling Information:'}
    line2 = {'en':' Stat Increases - Intelligence +2 and Charisma +2'}
    b(line1)
    b(line2)
    b({'en':' '})
    b(back)
    for i in range(1, 8):
        a.submenu(i, 'tiefling info')
    a.submenu(9, 'race info')
    a.prepuser = MenuSelect().TieflingPrep
    a.menuselect = MenuSelect().TieflingSelect
    
    for feat in Feat_Infos[gamedir]:
        a = popuplib.create('%s info'%feat)
        b = a.addline
        b({'en':'%s Information:'%feat})
        for line in Feat_Infos[gamedir][feat]['list']:
            b(Feat_Infos[gamedir][feat]['dict'][line])
        b({'en':'- -'})
        b(back)
        b(exit)
        for i in range(1, 9):
            a.submenu(i, '%s info'%feat)
        a.menuselectfb = MenuSelect().SelectFeat
        a.prepuser = MenuSelect().PrepFeat
    
    a = popuplib.create('stat menu')
    b = a.addline
    line1 = {'en':'How would you like to assign your ability points:'}
    line2 = {'en':'-> 1. Automatically'}
    line3 = {'en':'-> 2. Manually'}
    line4 = {'en':'-> 3. Ability Information'}
    b(line1)
    b(line2)
    b(line3)
    b(line4)
    a.select(1, MenuSelect().AutoStats)
    a.select(2, MenuSelect().StatManual)
    a.submenu(3, 'ability info')
    for i in range(4, 11):
        a.submenu(i, 'stat menu')
    
    a = popuplib.create('ability info')
    b = a.addline
    b({'en':'Select an Ability to Learn About:'})
    count = 1
    for Ability in Ability_List:
        b({'en':'-> %s. %s'%(count, Ability)})
        count += 1
    b(back)
    b(exit)
    a.menuselectfb = MenuSelect().AbilityInfoSelect
    abilsubs = {1:'Strength info',2:'Constitution info',3:'Dexterity info',4:'Intelligence info',5:'Wisdom info',6:'Charisma info',7:'ability info',8:'ability info'}
    for sub in abilsubs:
        a.submenu(sub, abilsubs[sub])
    
    for stat in Ability_Infos[gamedir]:
        a = popuplib.create('%s info'%stat)
        b = a.addline
        line1 = {'en':'%s Information:'%stat}
        b(line1)
        lines = len(Ability_Infos[gamedir][stat])
        count = 1
        while count <= lines:
            b(Ability_Infos[gamedir][stat]['line%s'%count])
            count += 1
        b(back)
        for i in range(1, 9):
            a.submenu(i, '%s info'%stat)
        a.submenu(10, 'ability info')
        a.submenu(9, 'ability info')
    
    a = popuplib.create('ranger type')
    b = a.addline
    line1 = {'en':'Select a ranger fighting style:'}
    line2 = {'en':'-> 1. Two Weapon'}
    line3 = {'en':'-> 2. Archer'}
    b(line1)
    b(line2)
    b(line3)
    a.menuselectfb = MenuSelect().RangerTypeSelect
    for i in range(3, 11):
        a.submenu(i, 'ranger type')
    
    for Class in Classes:
        a = popuplib.create('%s paragons'%Class)
        b = a.addline
        b({'en':'%s Paragon Paths:'%Class})
        count = 1
        for Paragon in Classes[Class]['paragon paths']:
            b({'en':'-> %s. %s'%(count, Paragon)})
            a.submenu(count, '%s info'%Paragon)
            count += 1
        for i in range(count+1, 9):
            a.submenu(i, '%s paragons'%Class)
        b(back)
        b(exit)
        a.submenu(9, '%s info'%Class)
    
    for Class in Classes:
        for Paragon in Paragon_Infos[gamedir][Class]:
            a = popuplib.create('%s info'%Paragon)
            b = a.addline
            b({'en':'%s Information:'%Paragon})
            lines = len(Paragon_Infos[gamedir][Class][Paragon])
            count = 1
            while count <= lines:
                b(Paragon_Infos[gamedir][Class][Paragon]['line%s'%count])
                count += 1
            b({'en':'-> 8. Select this Paragon Path'})
            for i in range(1, 8):
                a.submenu(i, '%s info'%Paragon)
            a.submenu(9, '%s paragons'%Class)
            b(back)
            b(exit)
            a.prepuser = MenuSelect().ParagonInfoPrep
            a.menuselectfb = MenuSelect().ParagonInfoSelect
    
    a = popuplib.create('11 choice')
    b = a.addline
    line1 = {'en':'Would you like to Multi Class or go into a Paragon Path:'}
    line2 = {'en':'-> 1. Multi Class'}
    line3 = {'en':'-> 2. Paragon Path'}
    b(line1)
    b(line2)
    b(line3)
    a.menuselect = MenuSelect().Choice11
    for i in range(3, 11):
        a.submenu(i, '11 choice')

''' line =  {'en':'',
             'de':'',
             'fr':''}'''
#Unsends all menus from a given user
def Unsend(userid):
    if not es.isbot(userid):
        count = popuplib.active(userid)['count']
        while count > 0:
            count -= 1
            if popuplib.active(userid)['name'] != '0':
                popuplib.close(popuplib.active(userid)['name'], userid)
#Our menu class, handels all static and dynamic menus
class MenuSelect(object):
    def Void(self, userid=None, choice=None, popupid=None):
        pass
    def Choice11(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(userid)['Character'].key['paragon path'] = 'multi classing'
            es.tell(userid, '#multi', text('Choice11 1',{},getPlayer(userid)['playerlib'].get('lang')))
            popuplib.send('class info', userid)
        elif choice == 2:
            for Class in getPlayer(userid)['Character'].key['classes']:
                popuplib.send('%s paragons'%Class, userid)
    def ParagonInfoPrep(self, userid=None, popupid=None):
        split = popupid.split(' ')
        Paragon = ''
        for word in split:
            if word != 'info':
                if Paragon:
                    Paragon = '%s %s'%(Paragon, word)
                else:
                    Paragon = word
        modline = len(Paragon_Infos[gamedir][Paragon_Infos[gamedir][Paragon]][Paragon])+2
        if getPlayer(userid)['Character'].key['paragon path'] == 'pending':
            popuplib.find(popupid).modlineAll(modline, {'en':'-> 8. Select this Paragon Path'})
        else:
            popuplib.find(popupid).modlineAll(modline, {'en':' '})
    def ParagonInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['paragon path'] == 'pending':
                split = popupid.split(' ')
                Paragon = ''
                for word in split:
                    if word != 'info':
                        if Paragon:
                            Paragon = '%s %s'%(Paragon, word)
                        else:
                            Paragon = word
                es.tell(userid, '#multi', text('ParagonInfoSelect 1',{'paragon':Paragon},getPlayer(userid)['playerlib'].get('lang')))
                getPlayer(userid)['Character'].key['paragon path'] = Paragon
            else:
                popuplib.send(popupid, userid)
    def RangerTypeSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(userid)['Character'].key['weapon type'] = 'two weapon'
        elif choice == 2:
            getPlayer(userid)['Character'].key['weapon type'] = 'archer'
    def AbilityInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9 or choice == 10:
            if not statCheck(userid):
                popuplib.send('stat menu', userid)
            else:
                if choice == 9:
                    popuplib.send('info menu', userid)
    def StatManual(self, userid=None, choice=None, popupid=None):
        AMenu = popuplib.easymenu('atmenu', None, self.StatManualSelect)
        abilities = getPlayer(userid)['Character'].key['abilities']
        count = 0
        for a in Ability_List:
            if not abilities[a]:
                count += 1
        key = {6:16,5:14,4:13,3:12,2:11,1:10}
        for a in Ability_List:
            if not abilities[a]:
                AMenu.addoption((a, key[count]), a)
        if count:
            AMenu.settitle('Select a stat to set to %s'%key[count])
            AMenu.send(userid)
        else:
            popuplib.send('race info', userid)
    def AutoStats(self, userid=None, choice=None, popupid=None):
        classes = getPlayer(userid)['Character'].key['classes']
        if 'Cleric' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':14,
                                    'Constitution':12,
                                    'Dexterity':11,
                                    'Intelligence':10,
                                    'Wisdom':16,
                                    'Charisma':13}
        elif 'Fighter' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':16,
                                        'Dexterity':13,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':11}
        elif 'Paladin' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':14,
                                        'Dexterity':11,
                                        'Intelligence':10,
                                        'Wisdom':12,
                                        'Charisma':13}
        elif 'Ranger' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':14,
                                        'Constitution':12,
                                        'Dexterity':16,
                                        'Intelligence':11,
                                        'Wisdom':13,
                                        'Charisma':10}
        elif 'Rogue' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':12,
                                        'Constitution':13,
                                        'Dexterity':16,
                                        'Intelligence':14,
                                        'Wisdom':11,
                                        'Charisma':10}
        elif 'Warlock' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':11,
                                        'Constitution':16,
                                        'Dexterity':12,
                                        'Intelligence':14,
                                        'Wisdom':10,
                                        'Charisma':13}
        elif 'Warlord' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':16,
                                        'Constitution':12,
                                        'Dexterity':11,
                                        'Intelligence':13,
                                        'Wisdom':10,
                                        'Charisma':14}
        elif 'Wizard' in classes:
            getPlayer(userid)['Character'].key['abilities'] = {'Strength':10,
                                        'Constitution':14,
                                        'Dexterity':13,
                                        'Intelligence':16,
                                        'Wisdom':12,
                                        'Charisma':11}
        else:
            popuplib.send('class info', userid)
        if len(classes):
            popuplib.send('race info', userid)
        for x in Ability_List:
            es.tell(userid, '#multi', text('StatSet',{'stat':x,'amount':getPlayer(userid)['Character'].key['abilities'][x]},getPlayer(userid)['playerlib'].get('lang')))
    def StatManualSelect(self, userid=None, choice=None, popupid=None):
        es.tell(userid, '#multi', text('StatSet',{'stat':choice[0],'amount':choice[1]},getPlayer(userid)['playerlib'].get('lang')))
        getPlayer(userid)['Character'].key['abilities'][choice[0]] = choice[1]
        self.StatManual(userid)
    def MainMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            if getPlayer(userid)['playerlib'].get('isdead') or int(es.getplayerteam(userid)) == 1:
                es.tell(userid, '#multi', text('MainMenuSelect 1',{},getPlayer(userid)['playerlib'].get('lang')))
                inputlib.InputChecker(userid).chatbox(30, 'dnd create', 'create character')
                #es.escinputbox(10, userid, text('MainMenuSelect 2',{},getPlayer(userid)['playerlib'].get('lang')), text('MainMenuSelect 3',{},getPlayer(userid)['playerlib'].get('lang')), 'dnd create')
            else:
                es.tell(userid, '#multi', text('MainMenuSelect 4',{},getPlayer(userid)['playerlib'].get('lang')))
        elif choice == 3:
            self.CharacterInformation(userid)
        elif choice == 5:
            getPlayer(userid)['Player'].DelCharacterMenu()
    def ClassMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9 or choice == 10:
            if not len(getPlayer(userid)['Character'].key['classes']):
                popuplib.send(popupid, userid)
            else:
                if choice == 9:
                    popuplib.send('info menu', userid)
    def SetPassword(self, userid=None, choice=None, popupid=None):
        if getPlayer(userid)['Character'].key['password'] == 'locked':
            es.tell(userid, '#multi', text('SetPassword 1',{},getPlayer(userid)['playerlib'].get('lang')))
            inputlib.InputChecker(userid).chatbox(30, 'dnd passwordset', 'set a password')
            #es.escinputbox(10, userid, text('SetPassword 1',{},getPlayer(userid)['playerlib'].get('lang')), text('SetPassword 2',{},getPlayer(userid)['playerlib'].get('lang')), 'dnd passwordset ')
        else:
            es.tell(userid, '#multi', text('SetPassword 3',{},getPlayer(userid)['playerlib'].get('lang')))
    def LoadMenuSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            getPlayer(userid)['Player'].CharacterMenu()
        elif choice == 3:
            es.tell(userid, '#multi', text('LoadMenuSelect 1',{},getPlayer(userid)['playerlib'].get('lang')))
            inputlib.InputChecker(userid).chatbox(30, 'dnd load', 'load a character')
            #es.escinputbox(10, userid, text('LoadMenuSelect 1',{},getPlayer(userid)['playerlib'].get('lang')), text('LoadMenuSelect 2',{},getPlayer(userid)['playerlib'].get('lang')), 'dnd load')
    def DemoCharacterSelect(self, userid=None, choice=None, popupid=None):
        #es.dbgmsg(0, 'Running DemoCharacter Select')
        getPlayer(userid)['Player'].key['character'] = Class_List[choice-1]
        es.tell(userid, '#multi', text('DemoCharacterSelect 1',{'class':Class_List[choice-1]},getPlayer(userid)['playerlib'].get('lang')))
    def CharacterInformation(self, userid=None, choice=None, popupid=None):
        character = getPlayer(userid)['Player'].key['character']
        statsmenu = popuplib.create('%s statsmenu'%userid)
        statsmenu.addline(text('CharacterInformation 1',{},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 2',{'character':character},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 3',{'xp':Characters[character]['xp'],'needed':Levels[Characters[character]['level']+1]},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 4',{'race':Characters[character]['race']},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 5',{},getPlayer(userid)['playerlib'].get('lang')))
        for c in sorted(Characters[character]['classes'].keys()):
            statsmenu.addline(' - %s (Level %s)'%(c, Characters[character]['classes'][c]['level']))
        if getPlayer(userid)['Character'].key['paragon path'] and getPlayer(userid)['Character'].key['paragon path'] != 'multi classing':
            statsmenu.addline(text('CharacterInformation 9',{'paragon':getPlayer(userid)['Character'].key['paragon path']},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline('Abilities:')
        abilities = Characters[character]['abilities']
        for a in Ability_List:
            statsmenu.addline(' - %s (%s)'%(a, abilities[a]))
        statsmenu.addline(text('CharacterInformation 6',{},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 7',{},getPlayer(userid)['playerlib'].get('lang')))
        statsmenu.addline(text('CharacterInformation 8',{},getPlayer(userid)['playerlib'].get('lang')))
        for i in range(1, 8):
            statsmenu.submenu(i, '%s statsmenu'%userid)
        statsmenu.submenu(9, 'main menu')
        statsmenu.select(8, self.CISelect)
        statsmenu.send(userid)
    def CISelect(self, userid=None, choice=None, popupid=None):
        character = getPlayer(userid)['Player'].key['character']
        sfmenu = popuplib.create('%s sfmenu'%userid)
        sfmenu.addline(text('ShowFeats 1',{'character':character},getPlayer(userid)['playerlib'].get('lang')))
        for f in Characters[character]['feats']:
            sfmenu.addline(' - %s'%f)
        if 'unspent' in getPlayer(userid)['Character'].key['feats']:
            sfmenu.addline(text('ShowFeats 2',{'character':character},getPlayer(userid)['playerlib'].get('lang')))
            getPlayer(userid)['Character'].AssesFeats()
            sfmenu.submenu(8, '%s can feats'%userid)
        else:
            sfmenu.submenu(8, '%s sfmenu'%userid)
        sfmenu.addline(back)
        sfmenu.addline(exit)
        for i in range(1, 8):
            sfmenu.submenu(i, '%s sfmenu'%userid)
        sfmenu.submenu(9, '%s statsmenu'%userid)
        sfmenu.send(userid)
    def IncreaseStat(self, userid=None, choice=None, popupid=None):
        if len(getPlayer(userid)['Character'].key['stat increase']):
            Unsend(userid)
            if 'last stat' not in getPlayer(userid)['Character'].key:
                getPlayer(userid)['Character'].key['last stat'] = None
            si = getPlayer(userid)['Character'].key['stat increase'][0]
            abilities = getPlayer(userid)['Character'].key['abilities']
            AMenu = popuplib.easymenu('amenu', None, self.IncreaseStatSelect)
            AMenu.settitle(text('IncreaseStat 1',{'amount':si[0],'reason':si[1]},getPlayer(userid)['playerlib'].get('lang')))
            for a in Ability_List:
                if a != getPlayer(userid)['Character'].key['last stat']:
                    AMenu.addoption((a,si[0]), '%s (%s)'%(a,abilities[a]))
            AMenu.send(userid)
    def IncreaseStatSelect(self, userid=None, choice=None, popupid=None):
        getPlayer(userid)['Character'].key['abilities'][choice[0]] += choice[1]
        getPlayer(userid)['Character'].key['last stat'] = choice[0]
        es.tell(userid, '#multi', text('IncreaseStatSelect 1',{'stat':choice[0],'value':getPlayer(userid)['Character'].key['abilities'][choice[0]]},getPlayer(userid)['playerlib'].get('lang')))
        getPlayer(userid)['Character'].key['stat increase'].remove(getPlayer(userid)['Character'].key['stat increase'][0])
        if len(getPlayer(userid)['Character'].key['stat increase']):
            self.IncreaseStat(userid)
        elif 'unspent' in getPlayer(userid)['Character'].key['feats']:
            getPlayer(userid)['Character'].AssesFeats()
            popuplib.send('%s can feats'%userid, userid)
    def ClassInfoPrep(self, userid=None,  popupid=None):
        if not len(getPlayer(userid)['Character'].key['classes']):
            popuplib.find(popupid).modlineAll(10, {'en':' '})
            popuplib.find(popupid).modlineAll(11, {'en':' '})
        else:
            popuplib.find(popupid).modlineAll(10, back)
            popuplib.find(popupid).modlineAll(11, exit)
    def ClassInfoSelect(self, userid=None, choice=None, popupid=None):
        if not len(getPlayer(userid)['Character'].key['classes']):
            popuplib.send(popupid, userid)
    def ClassesInfoPrep(self, userid=None,  popupid=None):
        Class = popupid.split(' ')[0]
        modline = len(Class_Infos[gamedir][Class]['base'])+1
        #es.msg('Modding Line %s'%modline)
        if not len(getPlayer(userid)['Character'].key['classes']):
            popuplib.find(popupid).modlineAll(modline, {'en':'-> 8. Select This Class'})
            popuplib.find(popupid).modlineAll(modline+2, {'en':' '})
        elif getPlayer(userid)['Character'].key['paragon path'] == 'multi classing' and Class not in getPlayer(userid)['Character'].key['classes']:
            popuplib.find(popupid).modlineAll(modline, {'en':'-> 8. Multi Class into %s'%Class})
            popuplib.find(popupid).modlineAll(modline+2, exit)
        else:
            popuplib.find(popupid).modlineAll(modline, {'en':' '})
            popuplib.find(popupid).modlineAll(modline+2, exit)
    def ClassesInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            Class = popupid.split(' ')[0]
            if not len(getPlayer(userid)['Character'].key['classes']):
                getPlayer(userid)['Character'].key['classes'][Class] = {'level':1}
                es.tell(userid, '#multi', text('ClassInfoSelect 1',{'class':Class},getPlayer(userid)['playerlib'].get('lang')))
                popuplib.send('stat menu', userid)
            elif getPlayer(userid)['Character'].key['paragon path'] == 'multi classing' and Class not in getPlayer(userid)['Character'].key['classes']:
                getPlayer(userid)['Character'].key['classes'][Class] = {'level':1}
                es.tell(userid, '#multi', text('ClassInfoSelect 2',{'class':Class},getPlayer(userid)['playerlib'].get('lang')))
            else:
                popuplib.send(popupid, userid)
        elif choice == 10:
            if not len(getPlayer(userid)['Character'].key['classes']):
                popuplib.send(popupid, userid)
    def RaceInfoPrep(self, userid=None,  popupid=None):
        #es.msg('%s race - %s'%(es.getplayername(userid), getPlayer(userid)['Character'].key['race']))
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            popuplib.find(popupid).modlineAll(10, {'en':' '})
            popuplib.find(popupid).modlineAll(11, {'en':' '})
        else:
            #es.msg('Else block')
            popuplib.find(popupid).modlineAll(10, back)
            popuplib.find(popupid).modlineAll(11, exit)
    def RaceInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 9 or choice == 10:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                popuplib.send(popupid, userid)
            else:
                if choice == 9:
                    popuplib.send('info menu', userid)
    def DragonbornPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def DragonbornSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Dragonborn'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Dragonborn'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Strength'] += 2
                abilities['Charisma'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def DwarfPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def DwarfSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Dwarf'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Dwarf'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Constitution'] += 2
                abilities['Wisdom'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def ElfPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def ElfSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Elf'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Elf'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Dexterity'] += 2
                abilities['Wisdom'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def EladrinPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def EladrinSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Eladrin'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Eladrin'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Dexterity'] += 2
                abilities['Intelligence'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def HalfElfPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def HalfElfSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Half Elf'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Half Elf'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Constitution'] += 2
                abilities['Charisma'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def HalflingPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def HalflingSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Halfling'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Halfling'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Dexterity'] += 2
                abilities['Charisma'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def HumanPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(4, line1)
        else:
            popuplib.find(popupid).modlineAll(4, {'en':' '})
    def HumanSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Human'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Human'},getPlayer(userid)['playerlib'].get('lang')))
                getPlayer(userid)['Character'].key['stat increase'].append([2, text('RaceSelect 2',{},getPlayer(userid)['playerlib'].get('lang'))])
                getPlayer(userid)['Character'].key['feats'].append('unspent')
                self.IncreaseStat(userid)
            else:
                popuplib.send(popupid, userid)
    def TieflingPrep(self, userid=None,  popupid=None):
        if getPlayer(userid)['Character'].key['race'] == 'pending':
            line1 = {'en':'-> 8. Select this Race'}
            popuplib.find(popupid).modlineAll(3, line1)
        else:
            popuplib.find(popupid).modlineAll(3, {'en':' '})
    def TieflingSelect(self, userid=None, choice=None, popupid=None):
        if choice == 8:
            if getPlayer(userid)['Character'].key['race'] == 'pending':
                getPlayer(userid)['Character'].key['race'] = 'Tiefling'
                es.tell(userid, '#multi', text('RaceSelect',{'race':'Tiefling'},getPlayer(userid)['playerlib'].get('lang')))
                abilities = getPlayer(userid)['Character'].key['abilities']
                abilities['Intelligence'] += 2
                abilities['Charisma'] += 2
                getPlayer(userid)['Character'].AssesFeats()
                popuplib.send('%s can feats'%userid, userid)
            else:
                popuplib.send(popupid, userid)
    def FeatInfoPrep(self, userid=None, popupid=None):
        if getPlayer(userid)['Player'].key['last asses'] != getPlayer(userid)['Player'].key['character']:
            getPlayer(userid)['Character'].AssesFeats()
    def FeatInfoSelect(self, userid=None, choice=None, popupid=None):
        if choice == 1:
            popuplib.send('%s feats'%userid, userid)
        elif choice == 2:
            popuplib.send('%s can feats'%userid, userid)
        elif choice == 3:
            popuplib.send('%s cant feats'%userid, userid)
    def CanFeatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            popuplib.send('feat info', userid)
        else:
            popuplib.send('%s info'%choice, userid)
    def CantFeatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            popuplib.send('feat info', userid)
        else:
            popuplib.send('%s info'%choice, userid)
    def FeatSelect(self, userid=None, choice=None, popupid=None):
        if choice == 'back':
            popuplib.send('feat info', userid)
        else:
            popuplib.send('%s info'%choice, userid)
    def PrepFeat(self, userid=None, popupid=None):
        split = popupid.split(' ')
        feat = ''
        for word in split:
            if word != 'info':
                if feat:
                    feat = '%s %s'%(feat, word)
                else:
                    feat = word
        if feat in getPlayer(userid)['Character'].key['can feats'] and 'unspent' in getPlayer(userid)['Character'].key['feats']:
            line = {'en':'-> 8. Gain this Feat'}
            popuplib.find(popupid).modlineAll(len(Feat_Infos[gamedir][feat]['list'])+2, line)
        else:
            popuplib.find(popupid).modlineAll(len(Feat_Infos[gamedir][feat]['list'])+2, {'en':'- -'})
    def SelectFeat(self, userid=None, choice=None, popupid=None):
        split = popupid.split(' ')
        feat = ''
        for word in split:
            if word != 'info':
                if feat:
                    feat = '%s %s'%(feat, word)
                else:
                    feat = word
        if choice == 8:
            if feat in getPlayer(userid)['Character'].key['can feats'] and 'unspent' in getPlayer(userid)['Character'].key['feats']:
                getPlayer(userid)['Character'].key['feats'].append(feat)
                getPlayer(userid)['Character'].key['feats'].remove('unspent')
                es.tell(userid, '#multi', text('SelectFeat 1',{'feat':feat},getPlayer(userid)['playerlib'].get('lang')))
                getPlayer(userid)['Character'].AssesFeats()
            else:
                popuplib.send(popupid, userid)
        elif choice == 9:
            key = getPlayer(userid)['Character'].key
            if feat in key['feats']:
                popuplib.send('%s feats'%userid, userid)
            elif feat in key['can feats']:
                popuplib.send('%s can feats'%userid, userid)
            elif feat in ket['cant feats']:
                popuplib.send('%s cant feats'%userid, userid)
            else:
                report('%s was not in %s\'s 3 feat groups'%(feat, es.getplayername(userid)))

#Begin Player Class
class Player(object):
    def __init__(self, userid):
        report('Start player init')
        self.userid = int(userid)
        self.steamid = playerlib.uniqueid(self.userid, True)
        if self.userid not in Players:
            Players[self.userid] = {}
            Players[self.userid]['character'] = None
            Players[self.userid]['pending'] = None
            Players[self.userid]['characters list'] = []
            Players[self.userid]['delay list'] = []
            Players[self.userid]['gravity'] = 1.0
            Players[self.userid]['long jump'] = 1.0
            Players[self.userid]['speed'] = 1.0
            Players[self.userid]['freeze'] = 0
            Players[self.userid]['last asses'] = None
        self.key = Players[self.userid]
        report('End player init')
    def KeySet(self, key, value):
        self.key[key] = value
    def KeyMod(self, key, value):
        self.key[key] += value
    def CheckCharacter(self):
        for x in Characters:
            if Characters[x]['creator'] == self.steamid:
                if not self.key['character']:
                    self.key['character'] = x
                if x not in self.key['characters list']:
                    self.key['characters list'].append(x)
        if not self.key['character']:
            getPlayer(self.userid)['Player'].key['character'] = 'Fighter'
            popuplib.send('help menu', self.userid)
    def AddCharacter(self, Name):
        self.key['characters list'].append(Name)
        self.key['character'] = Name
    def SetCharacter(self, Name):
        if Name in Characters:
            if not self.LoopCharacter(Name):
                self.key['character'] = Name
                es.tell(self.userid, '#multi', text('SetCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                es.tell(self.userid, '#multi', text('SetCharacter 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('SetCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def LoopCharacter(self, Name):
        for x in es.getUseridList():
            if Players[x]['character'] == Name and Character[Name]['password'] != 'demo':
                return 1
        return 0
    def TempCharacter(self, Name):
        if Name in Characters:
            if Characters[Name]['password'] != 'locked':
                self.key['pending'] = Name
                es.tell(self.userid, '#multi', text('TempCharacter 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
                inputlib.InputChecker(userid).chatbox(30, 'dnd passwordenter', 'enter a password')
                #es.escinputbox(10, self.userid, text('TempCharacter 2',{},getPlayer(self.userid)['playerlib'].get('lang')), text('TempCharacter 3',{},getPlayer(self.userid)['playerlib'].get('lang')), 'dnd passwordenter')
            else:
                es.tell(self.userid, '#multi', text('TempCharacter 3',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('TempCharacter 4',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def PasswordEnter(self, Password):
        if self.key['pending']:
            if Password == Characters[self.key['pending']]['password']:
                self.SetCharacter(self.key['pending'])
            else:
                es.tell(self.userid, '#multi', text('PasswordEnter 1',{'password':Password,'pending':self.key['pending']},getPlayer(self.userid)['playerlib'].get('lang')))
            self.key['pending'] = None
        else:
            es.tell(self.userid, '#multi', text('PasswordEnter 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def CharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', None, self.CharacterMenuSelect)
        CMenu.settitle(text('CharacterMenu 1',{'name':es.getplayername(self.userid)},getPlayer(self.userid)['playerlib'].get('lang')))
        for x in self.key['characters list']:
            if x != self.key['character']:
                CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def CharacterMenuSelect(self, userid, choice, popupid):
        es.sexec(self.userid, 'dnd load %s'%choice)
    def DelCharacterMenu(self):
        CMenu = popuplib.easymenu('CMenu', None, self.DelCharacterMenuSelect)
        CMenu.settitle(text('DelCharacterMenu 1',{'name':es.getplayername(self.userid)},getPlayer(self.userid)['playerlib'].get('lang')))
        for x in self.key['characters list']:
            if x != self.key['character']:
                CMenu.addoption(x, x)
        CMenu.send(self.userid)
    def DelCharacterMenuSelect(self, userid, choice, popupid):
        SMenu = popuplib.easymenu('sure Menu', None, self.DelSureSelect)
        SMenu.settitle(text('DelCharacterMenuSelect 1',{'name':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        SMenu.addoption(choice, 'Yes')
        SMenu.addoption('No', 'No')
        SMenu.send(self.userid)
    def DelSureSelect(self, userid, choice, popupid):
        if choice != 'No':
            self.key['characters list'].remove(choice)
            del Characters[choice]
            es.tell(self.userid, '#multi', text('DelSureSelect 1',{'name':choice},getPlayer(self.userid)['playerlib'].get('lang')))
        else:
            es.tell(self.userid, '#multi', text('DelSureSelect 2',{},getPlayer(self.userid)['playerlib'].get('lang')))
    def Delayed(self, duration, function, parama=(), Endround=None):
        if not Endround:
            gamethread.delayedname(duration, len(self.key['delay list'])+1, function, parama)
            self.key['delay list'].append(len(self.key['delay list'])+1)
        else:
            gamethread.delayedname(duration, len(Players['delay list'])+1, function, parama)
            Players['delay list'].append(len(Players['delay list'])+1)
    def Freeze(self, duration=None):
        self.key['freeze'] += 1
        es.setplayerprop(self.userid, "CBasePlayer.m_fFlags", 32.0)
        if duration:
            gamethread.delayed(duration, self.Unfreeze)
    def Unfreeze(self):
        if self.key['freeze'] > 0:
            self.key['freeze'] -= 1
        else:
            self.key['freeze'] = 0
        if not self.key['freeze']:
            es.setplayerprop(self.userid, "CBasePlayer.m_fFlags", 1)
    def Damage(self, damage, attacker, corelib=0):
        Health = int(es.getplayerprop(self.userid, 'CBasePlayer.m_iHealth'))
        report('Attacker: %s - Victim: %s - Damage: %s'%(es.getplayername(attacker), es.getplayername(self.userid), damage))
        if Health <= damage:
            #if not corelib:
            #    es.server.queuecmd('est_damage %s %s %s'%(attacker, self.userid, damage))
            #else:
            es.server.queuecmd('damage %s %s 32 %s'%(self.userid, damage, attacker))
        else:
            es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', Health-damage)
            #if gamevar:
                #def PlayerHurt(userid, attacker, damage, weapon, Classes, Character, Paragon):
            #    gamevar.PlayerHurt(self.userid, attacker, damage, 'point_hurt', getPlayer(self.userid)['Character'].key['classes'].keys(), getPlayer(self.userid)['Character'], getPlayer(self.userid)['Character'].key['paragon path'])
    def NearList(self, distance):
        x1,y1,z1 = es.getplayerlocation(self.userid)
        flist = []
        olist = []
        team = es.getplayerteam(self.userid)
        for id in es.getUseridList():
            if id != self.userid:
                x2,y2,z2 = es.getplayerlocation(id)
                if abs(x1-x2) < distance and abs(y1-y2) < distance and abs(z1-z2) < distance:
                    if team != es.getplayerteam(id):
                        olist.append(id)
                    else:
                        flist.append(id)
        return flist, olist
#End Player Class
#Begin Character Class
class Character(object):
    global Characters
    def __init__(self, userid=None):
        report('Character init start')
        self.userid = int(userid)
        self.steamid = playerlib.uniqueid(self.userid, True)
        if Players[self.userid]['character']:
            self.key = Characters[Players[self.userid]['character']]
            self.character = Players[self.userid]['character']
        else:
            self.key = None
            self.character = None
        report('Character init end')
    def AssesFeats(self):
        getPlayer(self.userid)['Player'].key['last asses'] = getPlayer(self.userid)['Player'].key['character']
        self.key['can feats'] = []
        self.key['cant feats'] = []
        for f in Feat_List:
            if f not in self.key['feats']:
                Req = Feats[f]['requirements']
                Good = 1
                for a in Req['abilities']:
                    if self.key['abilities'][a] < Req['abilities'][a]:
                        Good = 0
                if self.key['race'] not in Req['races'] and len(Req['races']):
                    Good = 0
                for c in Req['classes']:
                    if c in self.key['classes']:
                        if self.key['classes'][c]['level'] < Req['classes'][c]:
                            Good = 0
                            break
                    else:
                        Good = 0
                for feat in Req['feats']:
                    if feat not in self.key['feats']:
                        Good = 0
                if Req['level'] > self.key['level']:
                    Good = 0
                for c in Req['banned classes']:
                    if c in self.key['classes']:
                        Good = 0
                        break
                if Good:
                    self.key['can feats'].append(f)
                else:
                    self.key['cant feats'].append(f)
        counter = 0
        a = popuplib.easymenu('%s can feats'%self.userid, None, MenuSelect().CanFeatSelect)
        a.settitle('Feats %s can Learn:'%getPlayer(self.userid)['Player'].key['character'])
        for feat in self.key['can feats']:
            a.addoption(feat, feat)
            counter += 1
            if counter == 6:
                a.addoption('back','Back')
        if counter < 6:
            a.addoption('back','Back')
        a.c_beginsep = ""
        a.c_pagesep = ""
        counter = 0
        a = popuplib.easymenu('%s cant feats'%self.userid, None, MenuSelect().CantFeatSelect)
        a.settitle('Feats %s does not meet the Requirements for:'%getPlayer(self.userid)['Player'].key['character'])
        for feat in self.key['cant feats']:
            a.addoption(feat, feat)
            counter += 1
            if counter == 6:
                a.addoption('back','Back')
        if counter < 6:
            a.addoption('back','Back')
        a.c_beginsep = ""
        a.c_pagesep = ""
        counter = 0
        a = popuplib.easymenu('%s feats'%self.userid, None, MenuSelect().FeatSelect)
        a.settitle('Feats %s Has:'%getPlayer(self.userid)['Player'].key['character'])
        for feat in self.key['feats']:
            if feat != 'unspent':
                a.addoption(feat, feat)
                counter += 1
                if counter == 6:
                    a.addoption('back','Back')
        if counter < 6:
            a.addoption('back','Back')
        a.c_beginsep = ""
        a.c_pagesep = ""
    def Setup(self, Name, Forced=None):
        if Name not in Characters:
            if getPlayer(self.userid)['playerlib'].get('isdead') or int(es.getplayerteam(self.userid)) == 1:
                self.Create(Name)
            elif Forced:
                self.Create(Name)
            else:
                es.tell(self.userid, '#multi', text('Setup 1',{},getPlayer(self.userid)['playerlib'].get('lang')))
        elif Forced:
            self.Setup('%sX'%Name, 1)
        else:
            es.tell(self.userid, '#multi', text('Setup 2',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def Create(self, Name):
        Characters[Name] = {'creator':self.steamid,
                            'race':'pending',
                            'classes':{},
                            'feats':['unspent'],
                            'can feats':[],
                            'cant feats':[],
                            'abilities':{'Strength':None,
                                        'Constitution':None,
                                        'Dexterity':None,
                                        'Intelligence':None,
                                        'Wisdom':None,
                                        'Charisma':None},
                            'password':'locked',
                            'xp':0,
                            'level':1,
                            'stat increase':[],
                            'last stat':None,
                            'weapon type':None,
                            'paragon path':None}
        getPlayer(self.userid)['Player'].AddCharacter(Name)
        popuplib.send('class info', self.userid)
        self.key = Characters[Name]
        self.character = Name
        es.tell(self.userid, '#multi', text('Create 1',{'name':Name},getPlayer(self.userid)['playerlib'].get('lang')))
    def SetPassword(self, Password):
        if Password != 'locked' and Password != 'demo' and Password != 'public':
            Characters[Players[self.userid]['character']]['password'] = Password
            es.tell(self.userid, '#multi', text('SetPwd 1',{'character':Players[self.userid]['character'],'password':Password},getPlayer(self.userid)['playerlib'].get('lang')))
    def GiveXp(self, amount, reason):
        if self.key['password'] != 'demo':
            if self.key['xp'] < Levels[20]:
                self.key['xp'] += amount
                if self.key['xp'] >= Levels[self.key['level']+1]:
                    if self.key['level'] == 10:
                        getPlayer(self.userid)['Character'].key['paragon path'] = 'pending'
                        getPlayer(self.userid)['Menu'].ParagonMenu()
                    else:
                        self.GiveLevel(1)
                    es.tell(self.userid, '#multi', text('GiveXp 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
                else:
                    es.tell(self.userid, '#multi', text('GiveXp 2',{'amount':amount,'reason':reason},getPlayer(self.userid)['playerlib'].get('lang')))
            else:
                self.key['xp'] = Levels[20]
    def GiveLevel(self, amount, Class=None):
        while amount >= 1:
            self._GiveLevel(1, Class)
            amount -= 1
    def _GiveLevel(self, amount, Class=None):
        self.key['level'] += 1
        if self.key['level'] != 11 and self.key['level'] != 21:
            if Class:
                self.key['classes'][Class]['level'] += 1
            else:
                if len(self.key['classes']) == 1:
                    for c in self.key['classes']:
                        self.key['classes'][c]['level'] += 1
                else:
                    for c in self.key['classes']:
                        if self.key['classes'][c]['level'] < 10:
                            self.key['classes'][c]['level'] += 1
                            break
        else:
            self.key['paragon path'] = 'pending'
            es.tell(self.userid, '#multi', text('GiveLevel 3',{},getPlayer(self.userid)['playerlib'].get('lang')))
            popuplib.send('11 choice', self.userid)
        if self.key['level'] in Ability_Increases:
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
            getPlayer(self.userid)['Character'].key['stat increase'].append([1, text('GiveLevel 1',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang'))])
        if self.key['level'] in [11, 21]:
            for a in Ability_List:
                self.key['abilities'][a] += 1
            es.tell(self.userid, '#multi', text('GiveLevel 2',{'level':self.key['level']},getPlayer(self.userid)['playerlib'].get('lang')))
        if self.key['level'] in Feat_Increases:
            self.key['feats'].append('unspent')
#End Classes
#Begin handels for our 'dnd' command that can be run in client console/chat
def Command():
    userid = int(es.getcmduserid())
    steamid = playerlib.uniqueid(userid, True)
    player = getPlayer(userid)['playerlib']
    arg1 = es.getargv(1).lower()
    argcount = es.getargc()
    stringcount = 2
    commandstring = ''
    while stringcount < argcount:
        addstring = es.getargv(stringcount)
        if commandstring:
            commandstring = '%s %s'%(commandstring, addstring)
        else:
            commandstring = addstring
        stringcount += 1
    if arg1 == 'create':
        getPlayer(userid)['Character'].Setup(commandstring)
    elif arg1 == 'load':
        if player.get('isdead') or int(es.getplayerteam(userid)) == 1:
            if commandstring in Characters:
                if Characters[commandstring]['password'] == 'locked' and Characters[commandstring]['creator'] == steamid:
                    getPlayer(userid)['Player'].SetCharacter(commandstring)
                elif Characters[commandstring]['password'] == 'public':
                    getPlayer(userid)['Player'].SetCharacter(commandstring)
                else:
                    getPlayer(userid)['Player'].TempCharacter(commandstring)
            else:
                es.tell(userid, '#multi', text('Command 1',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', text('Command 2',{},player.get('lang')))
    elif arg1 == 'passwordenter':
        getPlayer(userid)['Player'].PasswordEnter(commandstring)
    elif arg1 == 'passwordset':
        getPlayer(userid)['Character'].SetPassword(commandstring)
    elif arg1 == 'loadmenu':
        getPlayer(userid)['Player'].CharacterMenu()
    elif arg1 == 'menu' or arg1 == 'mainmenu':
        popuplib.send('main menu', userid)
    elif arg1 == 'stats':
        getPlayer(userid)['Menu'].CharacterInformation(userid)
    elif arg1 == 'help' or arg1 == '':
        popuplib.send('help menu', userid)
    elif arg1 == 'info':
        popuplib.send('info menu', userid)
    else:
        es.tell(userid, '#multi', text('Command 3',{'commandstring':commandstring},getPlayer(userid)['playerlib'].get('lang')))
#End Character Class
#End our command handels
#Our Client Filter
def _cc_filter(userid, args):
    try:
        if not es.isbot(userid):
            if args[0].lower() == 'jointeam':
                if not len(getPlayer(userid)['Character'].key['classes']):
                    popuplib.send('class info', userid)
                    es.tell(userid, '#multi', text('player_spawn 1',{},getPlayer(userid)['playerlib'].get('lang')))
                    return False
                elif not statCheck(userid):
                    getPlayer(userid)['Menu'].StatManual(userid)
                    es.tell(userid, '#multi', text('player_spawn 2',{},getPlayer(userid)['playerlib'].get('lang')))
                    return False
                elif getPlayer(userid)['Character'].key['race'] == 'Pending':
                    popuplib.send('race info', userid)
                    es.tell(userid, '#multi', text('player_spawn 3',{},getPlayer(userid)['playerlib'].get('lang')))
                    return False
    except:
        for line in traceback.format_exception(*sys.exc_info()):
            es.dbgmsg(0, line[:~0])
    return True
